
/* 
 * SeroView.h -- Interface file for the SeroView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, or even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface GeomView:View {

	id		euRot;
	id		contourMenu;
	id		cosRot;
	id		cutAngle;
	id		cutData;
	id		cutMenu;
	id		cuttingMenu;
	id		cutSlider;
	id		angRot;
	id		axisButton;
	id		demoMenu;
	id		diagButton;
	id		dimerButton;
	id		frData;
	id		frPanel;
	id		fAtom;
	id		fCoord;
	id		goButton;
	id		gramMatrix;
	id		gridData;
	id		gridMenu;
	id		gridPanel;
	id		inspectBenzene;
	id		inspectFerrocene;
	id		inspectPolymer;
	id		inspectSulfur;
	id		inspectorSlider;
	id		inspectorMenu;
	id		inspectorText;
	id		leftAngles;
	id		leftCenter;
	id		leftEuler;
	id		leftRadius;
	id		orientButton;
	id		paramButton;
	id		penMatrix;
	id		triMatrix;
	id		polymerMatrix;
	id		primiMenu;
	id		quadDiagon;
	id		quadEigenv;
	id		quadMatrix;
	id		quadPanel;
	id		radiusSlider;
	id		repRef;
	id		rightAngles;
	id		rightCenter;
	id		rightEuler;
	id		rightRadius;
	id		rimButton;
	id		rotateDimer;
	id		showAtoms;
	id		showAxes;
	id		showBonds;
	id		showNuclei;
	id		showPen;
	id		sphereMenu;
	id		spiralData;
	id		spImButton;
	id		splitButton;
	id		traceMenu;
	id		angleParameters;
	id		spPanel;
	id		liPanel;
	id		lissaData;
	id		laloData;
	id		euPanel;
	id		pushMe;
	id		viewMenu;
	id		sulfAmplitude;
	id		sulfAtom;
	id		sulfError;
	id		sulfIndex;
	id		sulfRun;
	id		sulfShow;
	id		sulfSlider;
	id		sulfMatrix;
	id		sulfMenu;
	id		sulfText;
	id		sulfSet;

	id		theBenzView;
	id		theContView;
	id		theDiSpView;
	id		theFeroView;
	id		theGeomView;
	id		thePolymView;
	id		thePentaView;
	id		theQuarView;
	id		theReflView;
	id		theShadView;
	id		theSulfView;
	id		theThioView;
	id		theTridlView;
	id		theUnisView;

	id		benzWindow;
	id		contWindow;
	id		diSpWindow;
	id		feroWindow;
	id		geomWindow;
	id		infoPanel;
	id		pentaWindow;
	id		polymWindow;
	id		quarWindow;
	id		reflWindow;
	id		shadWindow;
	id		sulfWindow;
	id		thioWindow;
	id		tridlWindow;
	id		unisWindow;

	id		keyWindow;
	id		menuCopy;
	id		menuPrint;

	id		delegate;
	id		points;
	id		crossCursor;
	id		readOut;
	float		radius;
	BOOL		needsClearing;
}

- copyGEOM:sender;
- copySomeView:(int)viewnum:(int *)draw:theView;
- dismissPanels:sender;
- dLize:header;
- gramCent:sender;
- gramCosine:sender;
- gramProj:sender;
- gTri:sender;
- gPen:sender;
- gSulf:sender;
- inspectMolecule:sender;
- inspectorPanel:sender;
- iterCutting:sender;
- matrixPanel:sender;
- prepSpiral:sender;
- prepFractal:sender;
- prepGrid:sender;
- prepLissa:sender;
- printGEOM:sender;
- printMatrix:sender;
- printReflect:sender;
- printSphere:sender;
- printCutting:sender;
- printEdited:sender;
- printUnisphere:sender;
- printDisphere:sender;
- printSpIm:sender;
- pushIt:sender;
- qMom:sender;
- randCutting:sender;
- randReflect:sender;
- randReflectAll:sender;
- readAngleAxis:(double *)a:(double *)aa;
- readEulerAngles:sender;
- readParameters:sender;
- readQuartet:sender;
- reflectInCentral:sender;
- repeatReflect:sender;
- rotateDimerB:sender;
- rotateDimerF:sender;
- rotateDimerN:sender;
- rotateMolecule:sender;
- runNormalSulfMode:sender;
- setAngleC:sender;
- setAngleL:sender;
- setAngleR:sender;
- setDistance:sender;
- setDynTridMat:sender;
- setDynPentMat:sender;
- setDynSulfMat:sender;
- setLighting:sender;
- setOrigin:sender;
- setParameters:sender;
- setQuartet:sender;
- setRotation:sender;
- setPenPar:sender;
- setSulPar:sender;
- showContour:sender;
- showCutting:sender;
- showEditedMolecule:sender;
- showFatMolecule:sender;
- showInspectedMolecule:sender;
- showMatrix:sender;
- showNormalTridMode:sender;
- showNormalPentMode:sender;
- showNormalSulfMode:sender;
- showReflect:sender;
- showSphere:sender;
- showSplit:sender;
- showShadows:sender;
- showDisphere:sender;
- showAxSphere:sender;
- showEuSphere:sender;
- showUnisphere:sender;
- sliderOne:sender;
- sulfOne:sender;
- tryTriDemo:sender;
- usulf:sender;
- zsulf:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- clear:sender;
- Geom:sender;
- mouseDown:(NXEvent *)theEvent;
- registerPoint:(NXPoint *)aPoint;
- setRadius:(float)aFloat;
- (float)radius;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;
- awake;
- (const char *)inspectorName;
@end

@interface Object(PlotViewDelegate)
- PlotView:sender providePoints:(NXStream **)stream;
- PlotView:sender pointDidChange:(NXPoint *)aPoint;
@end


/* end GeomView.h */

