
#import "rec.h"
#import "sero.h"
#import "rectbl.h"
#import  <dpsclient/psops.h>
#import  <appkit/graphics.h>

# define HZAR	   500		/* array length for graph horizons	*/

int    options[4]={FALSE,FALSE,FALSE,FALSE};

extern double r_dblpar;	/* value of REC's $xxx.yy$ */

int    stackptr=-1;

int    RECOffset = 0;
double RECEnergy = 0.5;
double RECMass =   1.0;
double RECPoint =  0.0;
double RECPtntl[4];
double RECSolun[4];
double RECStep=0.1;
double RECPush[10];
double horhi[HZAR];
double horlo[HZAR];
double lastex, lastwy;

int    horix=0;
extern int ptj;

void videoplot(x,y,l) double x, y; int l; {
  if (l==0) PSmoveto(50.0*x,50.0*y); else PSlineto(50.0*x,50.0*y);}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/*             definition of REC operators and predicates                  */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

int rprze() {return(options[0]==TRUE);}
int rpron() {return(options[1]==TRUE);}
int rprtw() {return(options[2]==TRUE);}
int rprth() {return(options[3]==TRUE);}

void ropla() {RECOffset+=1; horix=0;}  /* increase offset, reset horizon */

void roplc() {RECPush[stackptr]=2.0*tanh(0.5*RECPush[stackptr]);}

void ropld() {RECStep*=r_dblpar;}	/* modify R-K step size */

void rople() {RECEnergy+=r_dblpar;}	/* modify Energy */

void roplf() {}				/* shorten step    */

void roplg() {double ex, wy;		/* graph additional points */
	if (stackptr >= 10 || stackptr < 1) return;
	wy=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	ex=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	videoplot(ex,wy,1);
	}

void roplh() {double x, y, z, ex, wy; int i; /* graph additional points */
	if (horix==0) return;
	if (stackptr >= 10 || stackptr < 1) return;
	wy=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	ex=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	i=horix+RECOffset;
	if (wy>=horhi[i]) {
	    horhi[i]=wy;
	    if (lastwy>=horhi[i-1]) {
		videoplot(lastex,lastwy,0);
		videoplot(ex,wy,1);
	    } else {
		z=(horhi[i]-horhi[i-1]-wy+lastwy);
		if (z==0.0) x=lastex; else 
			   x=lastex+(RECStep*(lastwy-horhi[i-1]))/z;
		y=lastwy+(x-lastex)*((wy-lastwy)/RECStep);
		videoplot(x,y,0);
		videoplot(ex,wy,1);
	        }
	    }
	if (wy<horhi[i] && lastwy>=horhi[i-1]) {
	    z=(horhi[i]-horhi[i-1]-wy+lastwy);
	    if (z==0.0) x=lastex; else 
		        x=lastex+(RECStep*(lastwy-horhi[i-1]))/z;
	    y=lastwy+(x-lastex)*((wy-lastwy)/RECStep);
	    videoplot(lastex,lastwy,0);
	    videoplot(x,y,1);
	    }
	if (wy<horlo[i]) {
	    horlo[i]=wy;
	    if (lastwy<horlo[i-1]) {
		videoplot(lastex,lastwy,0);
		videoplot(ex,wy,1);
	    } else {
		z=(horlo[i]-horlo[i-1]-wy+lastwy);
		if (z==0.0) x=lastex; else 
			   x=lastex+(RECStep*(lastwy-horlo[i-1]))/z;
		y=lastwy+(x-lastex)*((wy-lastwy)/RECStep);
		videoplot(x,y,0);
		videoplot(ex,wy,1);
	    }
		}
	if (wy>horlo[i] && lastwy<=horlo[i-1]) {
	    z=(horlo[i]-horlo[i-1]-wy+lastwy);
	    if (z==0.0) x=lastex; else 
		        x=lastex+(RECStep*(lastwy-horlo[i-1]))/z;
	    y=lastwy+(x-lastex)*((wy-lastwy)/RECStep);
	    videoplot(lastex,lastwy,0);
	    videoplot(x,y,1);
	    }
	lastex=ex; lastwy=wy;
	if (horix<HZAR-1) horix++;
	}

void ropli() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECSolun[0];
	}		/* j[0][0] solution element       */

void roplj() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECSolun[1];
	}		/* [0][1] solution element       */

void roplk() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECSolun[2];
	}		/* [1][0] solution element       */

void ropll() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECSolun[3];
	}		/* [1][1] solution element       */

void roplm() {}

void ropln() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=r_dblpar;
}			 /* push the $$ register */

void roplo() {RECPoint+=r_dblpar;}

void roplp() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECPush[stackptr-1];
}			/* copy top element on stack */

void roplq() {}

void roplr() {} 
		/* one step of fourth order Runge-Kutta integration */

void ropls() {} /* graph solution points */

void roplu() {}	
				/* put unit matrix as solution matrix */

void roplv() {				/* push independent variable */
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECPoint;
}	

/* ---- upper case ----- */

void ropua() {int i;			/* reset offset for plotted point */
	 horix=0;
	 RECOffset=0;
	 for (i=0; i<HZAR; i++) horhi[i]=-10.0;
	 for (i=0; i<HZAR; i++) horlo[i]= 10.0;
	}

void ropuc() {int c;			/* set color */
	PSstroke();
	c = *r_pc++;
	switch (c) {
	  case 'r': PSsetrgbcolor(1.0,0.0,0.0); break;
	  case 'g': PSsetrgbcolor(0.0,1.0,0.0); break;
	  case 'b': PSsetrgbcolor(0.0,0.0,1.0); break;
	  case 'c': PSsetcmykcolor(1.0,0.0,0.0,0.0); break;
	  case 'm': PSsetcmykcolor(0.0,1.0,0.0,0.0); break;
	  case 'y': PSsetcmykcolor(0.0,0.0,1.0,0.0); break;
	  case 'k': PSsetgray(NX_BLACK); break;
	  case 'd': PSsetgray(NX_DKGRAY); break;
	  case 'l': PSsetgray(NX_LTGRAY); break;
	  case 'w': PSsetgray(NX_WHITE); break;
default:  PSsetgray(NX_BLACK); break;}
}

void ropud() {RECStep=r_dblpar;}			/* set R-K step size */

void ropue() {RECEnergy=r_dblpar;}			/* set Energy */

int  rpruf() {return (RECPtntl[1]*RECPtntl[2]>=0.0);} 	/* coeff parity */

void ropug() {double ex, wy;			/* graph additional points */
	if (stackptr >= 10 || stackptr < 1) return;
	wy=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	ex=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	videoplot(ex,wy,0);
	}

void ropuh() {double ex, wy; int i;		/* graph first point 	   */
	wy=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	ex=RECPush[stackptr--]+((double)RECOffset)*RECStep;
	lastex=ex; lastwy=wy;
	i=horix+RECOffset;
	if (wy>horhi[i]) horhi[i]=wy;
	if (wy<horlo[i]) horlo[i]=wy;
	if (horix<HZAR-1) horix++;
	}

void ropui() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECPtntl[0];
	}				/* j[0][0] solution element       */

void ropuj() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECPtntl[1];
	}				/* [0][1] solution element       */

void ropuk() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECPtntl[2];
	}				/* [1][0] solution element       */

void ropul() {
	stackptr++;
	if (stackptr>=10) return;
	RECPush[stackptr]=RECPtntl[3];
	}				/* [1][1] solution element       */

void ropum() {}

void ropun() {}

void ropuo() {RECPoint=r_dblpar;}

void ropup() {if (stackptr<-1) {stackptr=-1; return;} else stackptr--;}

int  rpruq() {return(RECPush[stackptr]*RECPush[stackptr]>25.0);}	
			/* test for minimum scale */

void ropur() {}	
			/* one step sixth order Runge-Kutta integration */

void ropus(){}		/* graph 1st solution point */

void roput() {}		/* turn 60 deg right */

void ropuv() {}		/* choose potential */

/* ------------ */

void ropca() {}

void ropqm() {						/* print reg values */
	printf("z = %6.3f, E = %6.3f\n",RECPoint,RECEnergy);
	printf("Solution = (%6.3f,%6.3f,%6.3f,%6.3f)\n",
		RECSolun[0],
		RECSolun[1],
		RECSolun[2],
		RECSolun[3]);
	printf("Potential = (%6.3f,%6.3f,%6.3f,%6.3f)\n",
		RECPtntl[0],
		RECPtntl[1],
		RECPtntl[2],
		RECPtntl[3]);
	printf("\n");
}

int rprns() {return (int)(random()&01);}		/* random 1/2 pred */

int rprps() {return random()%10==1;}			/* random 1/10 pred */

/* end rec-geom.c */
