
/* GEOM.C 				*/
/* Harold V. McIntosh, 14 December 1972 */
/* 10 November 1990 - "C" version	*/

/*# include "bdos.h"*/
# import "geom.h"
# include <math.h>
# include <stdio.h>

# define COLGRAF     4  /* graph resolution			*/
# define T80X25      3  /* text resolution			*/
# define WHCYMAG     1  /* color quad for normal screen		*/
# define REDYEGR     2  /* color quad for normal screen		*/

# define DROWS		20	/* rows in demo menu	    */
# define DCOLS		32	/* second col in demo menu  */
# define PROWS		20	/* rows in parameter menu   */
# define SROWS		20	/* rows in screen menu	    */
# define SCOLS		10 	/* column width in screen m */

# define NX          	 3	/* number of sample rules   */
# define NP          	 7	/* number of parameters &c  */
# define NS          	 2	/* number of screen options */

# define RADH  0.30
# define RADC  0.75
# define RADFe 1.75
# define RADS  1.00

# define BONDCC  1.00
# define BONDCH  0.40
//# define BONDSS  2.08
# define BONDSS  1.08
# define BONDCFe 1.41

int    di, dj, pi, pj;				/* demo pointer, param ptr */
int    si, sj;					/* screen layout menu ptr  */
int    smen[NS];				/* screen menu options     */
int    slim[NS];				/* screen menu limits      */
int    tu[10], tv[15], tf[21];
int    bbe[12][12];
int    ni, nj;					/* time steps per graph */
int    dmii;					/* active demonstration */

double r0[3], r, a0[3], b0[3], m0[3];
double radhy, radca, radfe;
double o[3][3], mrot[3][3], s[5][8], t[5][8], u[10][8], uu[3][3];
double v[15][8], be[12][8], su[8][8], fc[21][8], rp[30][8], rl[64][8];
double qs[5][8], qt[5][8], qang[5];
double rf[6][8], mp[25][8];

double phami[33][33], pdiag[33][33];

double bep[5]  = {BONDCH, BONDCC, RADC, RADH, 1.0};
double sup[5]  = {BONDSS, RADS, 1.0, 1.0, 1.0};
double fcp[7]  = {BONDCH, BONDCC, BONDCFe, RADC, RADH, RADFe, 1.0};
double mpp[6]  = {BONDSS, 120.0, 45.0, RADS, 0.0, 0.0};

int    sspch=64;
int    sslen=2048;
int    sglon, sglat, sglen;
int    slthe, slphi, sllen;
int    frdepth=3;


void geommain() {
int    i;
char   k; 

// videomode(COLGRAF);
// videopalette(REDYEGR);
// videobackground(19);

k=' ';
di=0; dj=1;			/* demonstration menu */
pi=7; pj=0;			/* parameter menu     */
si=0; sj=1;			/* screen format menu */
dmii=1;				/* active demonstration */
smen[0]=0; slim[0]=3;		/* x-y, y-z, or x-r main graph	   */
smen[1]=0; slim[1]=2;		/* parabolic/cartesian coordinates */
r0[0]=r0[1]=r0[2]=0.0;
a0[0]=a0[1]=a0[2]=45.0;

sspch=81;
sslen=503;

geoii();

while (1!=0) {
//   videocursor(0,0,0); printf(" -GEOM-");
//   videocursor(0,2,0); printf("? %1c",k);
/*   scanf("%c",&k); 			     */
/*   while (k=='\032') scanf("%c",&k); 	     */
//    while (!kbdst()) videocursor(0,2,0);
   k=kbdin();
   if (k=='q') {videomode(T80X25); return;};
//   videocursor(0,2,0); printf(" %1c ",k);
   switch (k) {

  /* demonstration menu with typical parameters and initial conditions */

  case '\273': case '#':			/* F1 key */
    dmii=dmenu();
    videomode(COLGRAF);
    videopalette(REDYEGR);			/* white/cyan/magenta */
    break;

  /* parameter and initial condition menu activated for +,- */

  /* parameter and initial condition menu activated for +,- */

  case '\275': case '%':			/* F3 key */
    sj=smenu();    
    videomode(COLGRAF);
    videopalette(REDYEGR);			/* white/cyan/magenta */
    break;

case 'a':	/* show skeleton */
    geoni(dmii);
    break;

case 'b':
    eomsf(u,6);
    break;

case 'c':
    eomsf(t,3);
    geosp(t,0.5,3);
    eomsf(t,3);
    geosr(t,2.0,3);
    break;

case 'd':
    eomsf(v,12);
    break;

/* echo character from keyboard */

case 'e': 
    videocursor(0,0,15);
    printf("%1o",kbdin());
    break;

/* intersecting spheres */

case 'f':
    geosi(s);
    break;

/* coordinate grid */

case 'g':
    geodi(dmii);
    break;

case 'h':
    geosg(r0,1.5,a0,14,8);
    break;

case 'i':
    geosl(r0,1.25,a0,14,17);
    break;

case 'j':
    eomsf(t,3);
    break;

case 'k':
    geori(dmii);
    break;

case 'l':
    sphax(o,120.0,0.2,0.5,1.0);
    georf(t,o,3);
    eomsf(t,3);
    break;

case 'm':
    sphax(o,120.0,1.0,0.3,0.2);
    georf(t,o,3);
    eomsf(t,3);
    break;

case 'n':
    sphax(o,120.0,0.4,1.0,0.2);
    georf(t,o,3);
    eomsf(t,3);
    break;

/* read center of sphere */

case 'o':
    twopc('o');
    scanf("%F %F %F",&r0[0],&r0[1],&r0[2]);
    break;

/* read euler angles */

case 'u':
    twopc('u');
    scanf("%F %F %F",&a0[0],&a0[1],&a0[2]);
    break;

/* clear the screen */ 

case 'z':
    twopc('z');
    videomode(COLGRAF);
    videopalette(REDYEGR);
    videocursor(0,2,0);
    break;

/* ? --- menu listing */

  case '?':
    twopc('?');
    videomode(COLGRAF);
    videopalette(REDYEGR);
    videocursor(0,9,0);
    printf(" g - coordinate grid\n");
    printf(" m - more trajectory\n");
    printf(" p - parameters (g1,g2,z1,z2)\n");
    printf(" q - quit\n");
    printf(" t - trajectory\n");
    printf(" z - clear screen\n");
    printf(" ? - show menu\n");
    break;

  default: break;
  }  /* end switch */
}    /* end while  */

}  /* end main */

/* list of demonstration rules */
int dmenu() {int ii, jj; char c;
  videomode(T80X25);
  videocursor(0,0,0);  printf("Demonstrations for GEOM");
  videocursor(0,1,0);  printf(" 1 - sphere - spiral");
  videocursor(0,2,0);  printf(" 2 - sphere - lat and long");
  videocursor(0,3,0);  printf(" 3 - sphere - lissajous figure");
  videocursor(0,4,0);  printf(" 4 - pair of spheres");
  videocursor(0,5,0);  printf(" 5 - ");
  videocursor(0,6,0);  printf(" 6 - benzene molecule C6H6");
  videocursor(0,7,0);  printf(" 7 - ");
  videocursor(0,8,0);  printf(" 8 - sulfur ring S8");
  videocursor(0,9,0);  printf(" 9 - ");
  videocursor(0,10,0);  printf("10 - ferrocene molecule Fe(CH)5");
  videocursor(0,11,0);  printf("11");
  videocursor(0,12,0);  printf("12");
  videocursor(0,13,0);  printf("13");
  videocursor(0,14,0);  printf("14");
  videocursor(0,15,0);  printf("15");
  videocursor(0,16,0);  printf("16");
  videocursor(0,17,0);  printf("17");
  videocursor(0,18,0);  printf("18");
  videocursor(0,19,0);  printf("19");
  videocursor(0,20,0);  printf("20");
  videocursor(0,1,DCOLS);  printf("21");
  videocursor(0,2,DCOLS);  printf("22");
  videocursor(0,3,DCOLS);  printf("23");
  videocursor(0,4,DCOLS);  printf("24");
  videocursor(0,5,DCOLS);  printf("25");
  videocursor(0,6,DCOLS);  printf("26");
  videocursor(0,7,DCOLS);  printf("27");
  videocursor(0,8,DCOLS);  printf("28");
  videocursor(0,9,DCOLS);  printf("29");
  videocursor(0,10,DCOLS);  printf("30");
  videocursor(0,11,DCOLS);  printf("31");
  videocursor(0,12,DCOLS);  printf("32");
  videocursor(0,13,DCOLS);  printf("33");
  videocursor(0,14,DCOLS);  printf("34");
  videocursor(0,15,DCOLS);  printf("35");
  videocursor(0,16,DCOLS);  printf("36");
  videocursor(0,17,DCOLS);  printf("37");
  videocursor(0,18,DCOLS);  printf("38");
  videocursor(0,19,DCOLS);  printf("39");
  videocursor(0,20,DCOLS);  printf("40");
  videocursor(0,22,0);  printf("move cursor with arrows, select with <cr>\n");
  videocursor(0,23,0);  printf("position at top with <, bottom with >.\n");
  ii=DROWS; jj=DCOLS; c='!'; /* ii = max # rows, jj = second column */
  do {
    videocursor(0,di+1,dj);
    while (!kbdst()) videocursor(0,di+1,dj);
    c=kbdin();
      switch (c) {
      case '\013': case '\310': if (di==0) di=ii-1; else di--; break; /* up arrow */
      case '\012': case '\320': if (di==ii-1) di=0; else di++; break; /* down arrow */
      case '\014': case '\315': case ' ': dj=(dj==1?jj:1); break;     /* forward */
      case '\010': case '\313': dj=(dj==1?jj:1); break;		      /* backward */
      case '<': di=0; break;					      /* home */
      case '>': di=ii-1; break;					      /* bottom */
      default: break;
      }
    } while (c!='\015');
  return(di+ii*(dj==1?0:1)+1);
}

/* list of screen positions and options */
int smenu() {int ii, jj; char c;
  videomode(T80X25);
  videocursor(0,0,0);  printf("Screen positions and display options");
  videocursor(0,1,0);  printf("x-y plot,  x-z plot,  x-r plot");
  videocursor(0,2,0);  printf("elliptic,  cartesian,  parabolic");
  videocursor(0,3,0);  printf(" 3 - 1");
  videocursor(0,4,0);  printf(" 4 - ");
  videocursor(0,5,0);  printf(" 5 - ");
  videocursor(0,6,0);  printf(" 6 - ");
  videocursor(0,7,0);  printf(" 7 - ");
  videocursor(0,8,0);  printf(" 8");
  videocursor(0,9,0);  printf(" 9");
  videocursor(0,10,0);  printf("10");
  videocursor(0,11,0);  printf("11");
  videocursor(0,12,0);  printf("12");
  videocursor(0,13,0);  printf("13");
  videocursor(0,14,0);  printf("14");
  videocursor(0,15,0);  printf("15");
  videocursor(0,16,0);  printf("16");
  videocursor(0,17,0);  printf("17");
  videocursor(0,18,0);  printf("18");
  videocursor(0,19,0);  printf("19");
  videocursor(0,20,0);  printf("20");
  videocursor(0,22,0);  printf("move cursor with arrows, select with <cr>\n");
  videocursor(0,23,0);  printf("position at top with <, bottom with >.\n");
  ii=SROWS; jj=SCOLS; c='!'; /* ii = max # rows, jj = second column */
  do {
    sj=smen[si];
    videocursor(0,si+1,sj*jj);
    while (!kbdst()) videocursor(0,si+1,sj*jj);
    c=kbdin();
      switch (c) {
      case '\013': case '\310':
	if (si==0) si=ii-1; else si--; break;			/* up arrow */
      case '\012': case '\320':
	if (si==ii-1) si=0; else si++; break;			/* down arrow */
      case '\014': case '\315': case ' ':
	sj++; if (sj==slim[si]) sj=0; smen[si]=sj; break;	/* forward */
      case '\010': case '\313':
	if (sj==0) sj=slim[si]; sj--; smen[si]=sj; break;	/* backward */
      case '<':
	si=0; break;						/* home */
      case '>':
	si=ii-1; break;						/* bottom */
      default:
	break;
      }
    } while (c!='\015');
  return(si+1);
}

/* keyboard status */
int kbdst() {return(bdos(11) & 0xFF);}

/* direct keyboard input, no echo */
int kbdin() {int c;
  if ((c = bdos(7) & 0xFF) == '\0') c = (bdos(7) & 0xFF) | 0x80;
  return(c);
}

int bdos(i) int i; {}

/* read number from keyboard */
int numin(n) int n; {char c;
  c=kbdin();
  if (c>='0'&&c<='9') return(numin(10*n+(c-'0'))); else return(n);
}

/* @tanh.c */
/* #include	<errno.h> */

#define	P0	-0.161341190239962e4
#define	P1	-0.992259296722360e2
#define	P2	-0.964374927772254
#define	Q0	0.484023570719886e4
#define	Q1	0.223377207189623e4
#define	Q2	0.112744743805349e3

#define	XBIG		(27 * 0.693147180559945)
#define	LN3OVER2	0.549306144334054

// double	fabs();
// double	exp();

double	tanh(x)
	double	x;
	{
	double	f;
	double	g;
	double	pg, qg;

	f = fabs(x);
	if	(f > XBIG)
		f = 1.0;
	else if	(f > LN3OVER2){
		f = 0.5 - 1.0 / (exp(f + f) + 1.0);
		f = f + f;
		}
	else if	(f > 1e-8){
		g = f * f;
		pg = P0 + g * (P1 + g * P2);
		qg = Q0 + g * (Q1 + g * (Q2 + g));
		f = f + f * (g * (pg / qg));;
		}
	if	(x < 0)
		f = -f;
	return(f);
	}

/* geoii - initialize demonstrations */ 

void geoii() {int i, j;

sspch=81;
sslen=503;

r0[0]=r0[1]=r0[2]=0.0;
a0[0]=a0[1]=a0[2]=45.0;
b0[0]=b0[1]=b0[2]=30.0;

spheu(o,a0);
spheu(uu,b0);

radhy=0.50; radca=0.75;

tu[0]=3; for (i=1; i<5; i++) tu[i]=1;  tu[5]=2;

for (i=0; i<6; i++) tv[i]=1; for (i=6; i<12; i++) tv[i]=2;

for (i=0; i<5; i++) tf[i]=2; for (i=5; i<10; i++) tf[i]=1; tf[10]=3;
for (i=11; i<16; i++) tf[i]=1; for (i=16; i<21; i++) tf[i]=2;

    geoat(s,-0.8, 0.0, 0.3, 1.6, 30.0, 40.0, 59.0, 0);
    geoat(s, 0.6, 0.2,-0.2, 1.0,-30.0,-95.0,-22.0, 1);

    geoat(t,-0.8, 0.0, 0.3, 1.6, 30.0, 40.0, 59.0, 0);
    geoat(t, 0.6,-0.8,-0.2, 0.7,-30.0,-95.0,-22.0, 1);
    geoat(t, 0.9, 0.5, 0.0, 1.6, 40.0,-75.0,-62.0, 0);

    geoat(u, 0.0, 1.8, 0.0, 1.25, -45.0, 45.0, 45.0, 0);
    geoat(u, 1.7, 0.0, 1.4, 0.51, -50.0, 50.0, 40.0, 1);
    geoat(u, 0.8, 0.0, 0.9, 0.47,  32.0, 50.0, 42.0, 2);
    geoat(u,-0.3, 0.0,-0.2, 0.47,  30.0, 50.0, 40.0, 3);
    geoat(u,-0.9, 0.0,-1.1, 0.47,  30.0, 50.0, 37.0, 4);
    geoat(u,-1.3, 0.2, 0.8, 0.36,  36.0, 50.0, 40.0, 5);

    geoat(v,-1.0, 0.0, 0.0, 0.86,  30.0, 50.0, 40.0,  0);
    geoat(v,-0.5, 0.0, 0.8, 0.86,  30.0, 50.0, 40.0,  1);
    geoat(v, 0.5, 0.0, 0.8, 0.86,  30.0, 50.0, 40.0,  2);
    geoat(v, 1.0, 0.0, 0.0, 0.86,  30.0, 50.0, 40.0,  3);
    geoat(v, 0.5, 0.0,-0.8, 0.86,  30.0, 50.0, 40.0,  4);
    geoat(v,-0.5, 0.0,-0.8, 0.86,  30.0, 50.0, 40.0,  5);

    geoat(v,-1.8, 0.0, 0.0, 0.42, -60.0, 50.0, 40.0,  6);
    geoat(v,-0.9, 0.0, 1.6, 0.42, -60.0, 50.0, 40.0,  7);
    geoat(v, 0.9, 0.2, 1.6, 0.42, -60.0, 50.0, 40.0,  8);
    geoat(v, 1.8, 0.0, 0.0, 0.42, -60.0, 50.0, 40.0,  9);
    geoat(v, 0.9,-0.2,-1.6, 0.42, -60.0, 50.0, 40.0, 10);
    geoat(v,-0.9, 0.0,-1.7, 0.42, -60.0, 50.0, 40.0, 11);

    molbe(be,radca,1.2*radca,radhy,1.8*radca);

    molsu(su,sup[0],sup[1],8); geosp(su,0.67,8);

    molfc(fc,fcp[5],fcp[3],fcp[4],fcp[0]);

    molra(rp,27);

    molra(qt,5); thedr(qt);

    molla(rl,200,4);

    molmp(mp,mpp[0],mpp[1],mpp[2],mpp[3],17);

for (i=0; i<12; i++) for (j=0; j<12; j++) bbe[i][j]=0;
for (i=0; i<6; i++) bbe[i][(i+1)%6]=1;
for (i=0; i<6; i++) bbe[i][i+6]=1;

for (i=0; i<5; i++) qang[i]=90.0;

}

/* geopi - print the name of family i */

void geopi(n) int n; {
videocursor(0,24,0);
printf("                  ");
videocursor(0,24,0);
switch (n) {
case  0: printf("                  "); break;
case  1: printf("sphere - spiral"); break;
case  2: printf("sphere - lat, long"); break;
case  3: printf("sphere - lissaj"); break;
case  4: printf("pair of spheres"); break;
case  5: printf("planetary eclipse"); break;
case  6: printf("shadow sequence"); break;
case  7: printf("benzene ring"); break;
case  8: printf("sulfur molecule"); break;
case  9: printf("-9-"); break;
case 10: printf("ferrocene molecule"); break;
default: break;}
videocursor(0,2,0);
}

/* geoqi - print the name of ith parameter */

void geoqi(n) int n; {
videocursor(0,24,21);
printf("                  ");
videocursor(0,24,21);
switch (n) {
case  0: printf("                  "); break;
//case  1: printf("screen color (%2d)",bg); break;
case  2: printf("pitch  (%6d)",sspch); break;
case  3: printf("length  (%6d)",sslen); break;
case  4: printf("hydrogen (%4.2f)",radhy); break;
case  5: printf("carbon (%4.2f)",radca); break;
case  6: printf("sulfur (%4.2f)",RADS); break;
case  7: printf("iron (%4.2f)",radfe); break;
default: break;}
videocursor(0,2,0);
}


/* geodi - display spheres from family i */

void geodi(i) int i; {
switch (i) {
case  1: geoss(r0,1.75,a0); break;
case  2: geosg(r0,1.5,a0,14,8); break;
case  3: geosl(r0,1.82,a0,14,17); break;
case  4: geosi(s); break;
case  5: geomsf(u,tu,6); break;
case  6: shadsf(u,tu,uu,6); break;
// case  7: geomsf(be,abe,12); break;
case  8: eomsf(su,8); break;
case  9: geomsf(v,tv,12); break;
// case 10: geomsf(fc,afc,21); break;
case 11: geofr(r0,1.75,a0,3); break;
case 12: geofs(r0,1.75,a0,3); break;
case 13: geomsf(rp,tu,27); break;
case 14: geomsf(rl,tu,64); break;
default: break;
}}

/* geobf - bonds in a family of spheres */

void geobf(s,b,n) double s[][8]; int b[12][12], n; {
int    i, j, k, l, m, mm;
double b1, b2, dx, dy, dz;
double em, p[3];
mm=100;
em=((double)mm);
for (i=0; i<n; i++) for (j=0; j<n; j++) {
  if (b[i][j]==0) continue;
  p[0]=s[i][0]; dx=(s[j][0]-s[i][0])/em;
  p[1]=s[i][1]; dy=(s[j][1]-s[i][1])/em;
  p[2]=s[i][2]; dz=(s[j][2]-s[i][2])/em;
  pltms(p[0],p[2],0);
  for (k=0; k<mm; k++) {
    m=1;
    for (l=0; l<n; l++) {
      sphdj(&b1,&b2,p,&s[l][0],s[l][3]);
      if (b1<0.0)        {m=0; break;}
      if (p[1]<=s[l][1]) continue;
      if (b2<=0.0)       {m=0; break;}
      }  /* end for l */
    pltms(p[0],p[2],m);
    p[0]+=dx; p[1]+=dy; p[2]+=dz;
    }  /* end for k   */
  }    /* end for i,j */
}

/* geodax - draw axes in a family of spheres */

void geodax(s,o,n) double s[][8], o[3][3]; int n; {
int    i, j, k, m, mm;
double b1, b2, dx;
double p[3], w[3];
double em;
mm=64;
em=((double)mm);
dx=7.0/em;
for (i=0; i<3; i++) {
  sphzv(p);
  p[i]=-3.5;
  pltms(p[0],p[2],0);
  for (j=0; j<mm; j++) {
    m=1;
    sphmv(w,o,p);
    for (k=0; k<n; k++) {
      sphdj(&b1,&b2,w,&s[k][0],s[k][3]);
      if (b1<0.0)        {m=0; break;}
      if (w[1]<=s[k][1]) continue;
      if (b2<0.0)        {m=0; break;}
      } /* end for k */
    pltms(w[0],w[2],m);
    p[i]+=dx;
    }  /* end for j   */
  }    /* end for i   */
}

/* geobo - draw bonds for family i */

void geobo(i) int i; {
switch (i) {
case  1: break;
case  2: break;
case  3: break;
case  4: break;
case  5: break;
case  6: break;
case  7: geosr(be,0.20,12); geobf(be,bbe,12); geosr(be,5.0,12); break;
case  8: break;
case  9: break;
case 10: break;
default: break;
}}

/* calculate dipole moment */

void geodm(w,s,n) double w[3], s[][8]; int n; {
double en; int i, j;
en=(double)n;
                    for (i=0; i<3; i++) w[i]=0.0;
for (j=0; j<n; j++) for (i=0; i<3; i++) w[i]+=s[j][i]; 
                    for (i=0; i<3; i++) w[i]/=en;
}

/* calculate quadrupole moment */

void geoqm(q,s,n) double q[3][3], s[][8]; int n; {
double en; int i, j, k;
en=(double)n;
for (i=0; i<3; i++) for (j=0; j<3; j++) q[i][j]=0.0;
for (k=0; k<n; k++) 
  for (i=0; i<3; i++) for (j=0; j<3; j++) q[i][j]+=s[k][i]*s[k][j];
for (i=0; i<3; i++) for (j=0; j<3; j++) q[i][j]/=en;
}

/* geoil - interrupted line */

void geoil(p1,q1,p2,q2) double *p1, q1, *p2, q2; {
double x1, z1, x2, z2;
x1=p1[0];
z1=p1[2];
x2=p2[0];
z2=p2[2];
if (q1<0.0) {
  if (q2<0.0) {pltms(x2,z2,0); return;} else {
    x1=x1-q1*((x2-x1)/(q2-q1));
    z1=z1-q1*((z2-z1)/(q2-q1));
    pltms(x1,z1,0);
    pltms(z2,z2,1);
    return;
    }
  } else {
  if (q2>0.0) {pltms(x2,z2,1); return;} else {
    x1=x1-q1*((x2-x1)/(q2-q1));
    z1=z1-q1*((z2-z1)/(q2-q1));
    pltms(x1,z1,1);
    pltms(z2,z2,0);
    return;
    }
  }
}

/* geoni - show the nuclei of the spheres from family i */

void geoni(n) int n; {double o[3][3];
switch (n) {
case  1: break;
case  2: break;
case  3: break;
case  4: break;
case  5: geosr(u,0.20, 6); eomsf(u, 6); geosr(u,5.0, 6); break;
case  6: geosr(v,0.20,12); eomsf(v,12); geosr(v,5.0,12); break;
case  7: geosr(v,0.20,12); eomsf(v,12); geosr(v,5.0,12); break;
case  8: geosr(su,0.20,8); eomsf(su,8); geosr(su,5.0,8); break;
case  9: geosr(v,0.20,12); eomsf(v,12); geosr(v,5.0,12); break;
case 10: geosr(fc,0.20,21); eomsf(fc,21); geosr(fc,5.0,8); break;
default: break;
}}

/* geori - rotate spheres from family i */

void geori(n) int n; {double o[3][3];
sphax(o,60.0,1.0,1.0,1.0);
switch (n) {
case  1: break;
case  2: break;
case  3: break;
case  4: break;
case  5: georf(u,o,6);  break;
case  6: georf(u,o,6);  break;
case  7: georf(be,o,12); break;
case  8: georf(su,o,8); break;
case  9: break;
case 10: georf(fc,o,21); break;
default: break;
}}

/* eomsf - intersection of a family of spheres */

void eomsf(s,n) double s[][8]; int n; {
int    i, j, k, mi;
double b1, b2, g, th, dh, ri;
double emi, p[3], o[3][3], u0, u2, q, qq;
for (i=0; i<n; i++) {
  ri=s[i][3];
  g=49.0*ri;
  emi=1024.0*ri*ri;
  mi=(int)emi;
  dh=3.14159/emi;
  spheu(o,&s[i][4]);
    sphrv(p,ri,0.0,0.0);
    sphap(p,o,p,&s[i][0]);
    pltms(p[0],p[2],0);
    qq=-1.0; u0=p[0]; u2=p[2];
  for (k=0, th=0.0; k<mi; k++) {
    th+=dh;
    sphrv(p,ri,th,g*th);
    sphap(p,o,p,&s[i][0]);
    if  (p[1]>s[i][1]) q=-0.1;              /* own backside */
      else {
        q=0.1;
        for (j=0; j<n; j++) {
          if (i==j) continue;
          sphdj(&b1,&b2,p,s,j);
          if (b1<0.0)        {q=b1; break;} /* inside jth sphere     */
          if (p[1]<=s[j][1]) continue;      /* in front, try another */
          if (b2<=0.0)       {q=b2; break;} /* occluded, stop now    */
          }  /* end for j */
        }    /* end else */
    pltil(u0,u2,qq,p[0],p[2],q);
    qq=q; u0=p[0]; u2=p[2];
    }  /* end for k */
  }    /* end for i */
}

/* geomsf - present a family of spheres in color */

void geomsf(s,t,n) double s[][8]; int *t, n; {
int    i, j, k, m, mi;
double b1, b2, g, th, dh, ri;
double emi, p[3], o[3][3];
g=(double)sspch;
for (i=0; i<n; i++) {
  ri=s[i][3];
  emi=((double)sslen)*ri;
  mi=(int)emi;
  dh=3.14159/emi;
  th=0.0;
  spheu(o,&s[i][4]);
  for (k=0; k<mi; k++) {
    th+=dh;
    sphrv(p,ri,th,g*th);
    sphap(p,o,p,&s[i][0]);
    if  (p[1]>s[i][1]) continue;
    m=1;
    for (j=0; j<n; j++) {
      if (i==j) continue;
      sphdj(&b1,&b2,p,&s[j][0],s[j][3]);
      if (b1<0.0)        {m=0; break;}
      if (p[1]<=s[j][1]) continue;
      if (b2<=0.0)       {m=0; break;}
      }  /* end for j */
    geomms(p[0],p[2],m,t[i]);
    }  /* end for k */
//  if (kbdst()) {kbdin(); break;}
  }    /* end for i */
}

/* shadsf - present a family of spheres with shadows */
/* s[n][8] - family of spheres			     */
/* u[3][3] - direction of illumination		     */
/* t[n] -    color codes			     */


void shadsf(s,t,u,n) double s[][8], u[3][3]; int *t, n; {
int    i, j, k, m, mi;
double b1, b2, g, th, dh, ri;
double emi, p[3], q[3], r[3], a[3], b[3], o[3][3];
g=(double)sspch;
for (i=0; i<n; i++) {
  ri=s[i][3];
  emi=((double)sslen)*ri;
  mi=(int)emi;
  dh=3.14159/emi;
  th=0.0;
  spheu(o,&s[i][4]);
  for (k=0; k<mi; k++) {
    th+=dh;
    sphrv(a,ri,th,g*th);
    sphmv(r,o,a);
    sphmv(q,u,r);
    sphvs(p,r,&s[i][0]);
    if (r[1]>0.0) {pltms(p[0],p[2],0); continue;}
    if (q[1]>0.0) {pltms(p[0],p[2],0); continue;}
    if (k==0) pltms(p[0],p[2],0);
    sphmv(b,u,p);
    m=1;
    for (j=0; j<n; j++) {
      if (i==j) continue;
      sphdj(&b1,&b2,p,&s[j][0],s[j][3]);
      if (b1<0.0)        {m=0; break;}
      if (p[1]<=s[j][1]) continue;
      if (b2<=0.0)       {m=0; break;}
      sphmv(q,u,&s[j][0]);
      sphdj(&b1,&b2,b,q,s[j][3]);
      if (b1<0.0)        {m=0; break;}
      if (b[1]<=q[1])    continue;
      if (b2<=0.0)       {m=0; break;}
      }  /* end for j */
//    geomms(p[0],p[2],m,t[i]);
    pltms(p[0],p[2],m);
    }  /* end for k */
//  if (kbdst()) {kbdin(); break;}
  }    /* end for i */
}

/* fsisf - intersection of a family of spheres */

void fsisf(s,n,l) double s[][8]; int n, l; {
int    i, j, k, mi;
int    i0, i1, i2;
double b1, b2, f, g, th, dh, ri;
double emi, p[3], o[3][3], u0, u2, q, qq;
double xx, yy, zz, rr, y0;
if (l==0) {i0=0; i1=1; i2=2, f=-1.0;}
if (l==1) {i0=1; i1=0; i2=2, f= 1.0;}
if (l==2) {i0=0; i1=2; i2=1, f= 1.0;}
for (i=0; i<n; i++) {
  ri=s[i][3];
  y0=s[i][i1];
  g=81.0*ri;
  emi=1724.0*ri*ri;
  mi=(int)emi;
  dh=3.14159/emi;
  spheu(o,&s[i][4]);
    sphrv(p,ri,0.0,0.0);
    sphap(p,o,p,&s[i][0]);
    pltms(p[i0],p[i2],0);
    qq=-1.0; u0=p[i0]; u2=p[i2];
  for (k=0, th=0.0; k<mi; k++) {
    th+=dh;
    sphrv(p,ri,th,g*th);
    sphap(p,o,p,&s[i][0]);
    if  (f*(p[i1]-y0)<0.0) q=-1.0;          /* own backside */
      else {
        q=1.0;
        for (j=0; j<n; j++) {
          if (i==j) continue;
xx=p[i0]-s[j][i0]; xx*=xx;
yy=p[i1]-s[j][i1]; yy*=yy;
zz=p[i2]-s[j][i2]; zz*=zz;
rr=s[j][3]; rr*=rr;
b1=xx+yy+zz-rr;
b2=xx+zz-rr;

//          sphdj(&b1,&b2,p,s,j);
          if (b1<0.0)             {q=b1; break;} /* inside jth sphere     */
          if (f*(p[i1]-s[j][i1])>=0.0) continue; /* in front, try another */
          if (b2<0.0)             {q=b2; break;} /* occluded, stop now    */
          }  /* end for j */
        }    /* end else */
    pltil(u0,u2,qq,p[i0],p[i2],q);
    qq=q; u0=p[i0]; u2=p[i2];
    }  /* end for k */
  }    /* end for i */
}

/* georf - rotated family */

void georf(s,o,n) double s[][8], o[][3]; int n; {
int i;
for (i=0; i<n; i++) sphmv(&s[i][0],o,&s[i][0]);
}

/* geotf - translated family */

void geotf(s,z,n) double s[][8], z[3]; int n; {
int i, j;
for (i=0; i<n; i++) for (j=0; j<3; j++) s[i][j]+=z[j];
}

/* geoat - insert all eight atomic values into chain */

void geoat(s,x,y,z,r,a,b,c,n) double s[][8], x, y, z, r, a, b, c; int n; {
s[n][0]=x;
s[n][1]=y;
s[n][2]=z;
s[n][3]=r;
s[n][4]=a;
s[n][5]=b;
s[n][6]=c;
s[n][7]=r*r;
}

/* geoav - insert atomic values into chain */

void geoav(s,x,y,z,r,n) double s[][8], x, y, z, r; int n; {
s[n][0]=x;
s[n][1]=y;
s[n][2]=z;
s[n][3]=r;
s[n][4]=45.0;
s[n][5]=45.0;
s[n][6]=45.0;
s[n][7]=r*r;
}

/* geosg - represent a sphere by latitude and longitude	*/

void geosg(r0,r,a0,m,l) double *r0, r, *a0; int m, l; {
int    i, j, np;
double th, ph, dt, dp, enp, y0;
double o[3][3], w[3];

np=72;
enp=(double)(np+1);
y0=r0[1];
spheu(o,a0);
dt=3.14159/((double)(l+1));
dp=6.28318/enp;
th=3.14159-dt;
for (i=0, ph=0.0; i<l; i++, th-=dt) {
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],0);
  for (j=0; j<np; j++) {
    ph+=dp;
    sphrv(w,r,th,ph);
    sphap(w,o,w,r0);
    pltms(w[0],w[2],w[1]>=y0);
    }}
dt=3.14159/enp;
dp=6.28318/((double)(m+1));
for (i=0, ph=0.0; i<m; i++, ph+=dp) {
  th=0.0;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],0);
  for (j=0; j<np; j++) {
    th+=dt;
    sphrv(w,r,th,ph);
    sphap(w,o,w,r0);
    pltms(w[0],w[2],w[1]>=y0);
    }}
}

/* geomsg - represent a sphere by latitude and longitude	*/
/* version in which all the parameters are explicit arguments	*/
/* *r0 center of the sphere					*/
/*   r radius of the sphere					*/
/* *a0 orientation parameters (Euler angles)			*/
/*   m number of longitudes (1 = greenwich only)		*/
/*   l number of latitudes (1 = equator only)			*/
/*  lo increments per longitude					*/
/*  la increments per latitude					*/

void geomsg(r0,r,a0,m,l,lo,la) double *r0, r, *a0; int m, l, la, lo; {
int    i, j;
double th, ph, dt, dp, enp, y0;
double o[3][3], w[3];

/* draw the latitudes */

enp=(double)(la);
y0=r0[1];
spheu(o,a0);
dt=3.14159/((double)(l+1));
dp=6.28318/enp;
for (i=0, th=3.14159-dt; i<l; i++, th-=dt) {
  ph=0.0;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],0);
  for (j=0; j<la; j++) {
    ph+=dp;
    sphrv(w,r,th,ph);
    sphap(w,o,w,r0);
    pltms(w[0],w[2],w[1]>=y0);
    }
  }

/* draw the longitudes */

enp=(double)(lo+2);
dt=3.14159/enp;
dp=6.28318/((double)(m));
for (i=0, ph=0.0; i<m; i++, ph+=dp) {
  th=3.14159-dt;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],0);
  for (j=0; j<lo; j++) {
    th-=dt;
    sphrv(w,r,th,ph);
    sphap(w,o,w,r0);
    pltms(w[0],w[2],w[1]>=y0);
    }
  }
}

/* geosi - intersection of two spheres */

void geosi(s) double s[][8]; {
int    i, j, k, l, n, m, m0;
double b[3], c[3], g, th, dh, ri;
double xx, yy, zz, rr, wy, y0;
double w[3], u[3], o[3][3];
n=4096;
n=2048;
n=256;
n=1024;
g=128.0;
g=64.0;
g=53.0;
dh=3.14159/((double)n);
for (i=0; i<2; i++) {
  y0=s[i][1];
for (j=0; j<2; j++) {
  if (i==j) continue;
  th=0.0;
  ri=s[i][3];
  spheu(o,&s[i][4]);
  sphrv(w,ri,th,g*th);
  sphap(u,o,w,&s[i][0]);
  pltms(u[0],u[2],0);
  m0=3;
  for (l=0; l<3; l++) c[l]=-1.0;
  for (k=0; k<n; k++) {
    th+=dh;
    sphrv(w,ri,th,g*th);
    sphap(w,o,w,&s[i][0]);
    xx=w[0]-s[j][0]; xx*=xx;
    wy=w[1]-s[j][1]; yy=wy*wy;
    zz=w[2]-s[j][2]; zz*=zz;
    rr=s[j][3]; rr*=rr;
    b[0]=xx+yy+zz-rr;		/* spherical radius	*/
    b[1]=wy>0?b[0]-yy:1.0;	/* cylindrical radius	*/
    b[2]=y0-w[1];		/* behind own equator	*/
    for (l=0, m=3; l<3; l++) {if (b[l]<0.0) {m=l; break;}}

    if (m0<3) 
      if (m<3) pltil(u[0],u[2], -1.0,w[0],w[2], -1.0);
      else pltil(u[0],u[2],c[m0],w[0],w[2],b[m0]);
    else if (m<3)  pltil(u[0],u[2], c[m],w[0],w[2], b[m]);
      else pltil(u[0],u[2],  1.0,w[0],w[2],  1.0);

    m0=m;
    for (l=0; l<3; l++) u[l]=w[l];
    for (l=0; l<3; l++) c[l]=b[l];
    }  /* end for k (points on spiral) */
  }    /* end for j (other spheres)    */
  }    /* end for i (each sphere)      */
}

/* geoci - circle of intersection of two spheres */

void geoci(s) double s[][8]; {
int    i, n;
double a, b, c, r, r01, t, u[3], v[3], w[3];
double x1, y1, z1, r1;
double x0, y0, z0, r0;
double th, dh, ex, wy, ze;
x0=s[0][0]; y0=s[0][1]; z0=s[0][2]; r0=s[0][3];
x1=s[1][0]; y1=s[1][1]; z1=s[1][2]; r1=s[1][3];
u[0]=a=x1-x0; u[1]=b=y1-y0; u[2]=c=z1-z0;
v[0]=b; v[1]=-a; v[2]=0.0;
w[0]=-a*c; w[1]=-b*c; w[2]=a*a+b*b;
r=a*a+b*b+c*c; r01=sqrt(r);
if (r0+r1<r01) return;
t=r0-r1; if (t<0) t=-t;
if (t>r01) return;
t=(r+r0*r0-r1*r1)/(2.0*r01);
for (i=0; i<3; i++) u[i]*=t/r01;
t=sqrt(r0*r0-t*t);
r=sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
for (i=0; i<3; i++) v[i]*=t/r;
r=sqrt(w[0]*w[0]+w[1]*w[1]+w[2]*w[2]);
for (i=0; i<3; i++) w[i]*=t/r;

n=128;
th=0.0;
// printf("u:%6.3f, %6.3f, %6.3f\n",u[0],u[1],u[2]); 
// printf("v:%6.3f, %6.3f, %6.3f\n",v[0],v[1],v[2]); 
// printf("w:%6.3f, %6.3f, %6.3f\n\n",w[0],w[1],w[2]); 
dh=6.2830/((double)(n-1));
ex=x0+u[0]+cos(th)*v[0]+sin(th)*w[0];
ze=z0+u[2]+cos(th)*v[2]+sin(th)*w[2];
pltms(ex,ze,0);
for (i=0; i<n; i++, th+=dh) {
  ex=x0+u[0]+cos(th)*v[0]+sin(th)*w[0];
  wy=y0+u[1]+cos(th)*v[1]+sin(th)*w[1];
  ze=z0+u[2]+cos(th)*v[2]+sin(th)*w[2];
  pltms(ex,ze,wy<y0 && wy<y1);
  }

n=128;
th=0.0;
ex=x0+r0*cos(th);
ze=z0+r0*sin(th);
pltms(ex,ze,0);
for (i=0; i<n; i++, th+=dh) {
  ex=x0+r0*cos(th);
  ze=z0+r0*sin(th);
    pltms(ex,ze,((y0>y1)&&((ex-x1)*(ex-x1)+(ze-z1)*(ze-z1)>=r1*r1))
      ||((y0<y1)&&((ex-x1)*(ex-x1)+(y0-y1)*(y0-y1)+(ze-z1)*(ze-z1))>=r1*r1));
  }

n=128;
th=0.0;
ex=x1+r1*cos(th);
ze=z1+r1*sin(th);
pltms(ex,ze,0);
for (i=0; i<n; i++, th+=dh) {
  ex=x1+r1*cos(th);
  ze=z1+r1*sin(th);
    pltms(ex,ze,((y1>y0)&&((ex-x0)*(ex-x0)+(ze-z0)*(ze-z0)>=r0*r0))
      ||((y1<y0)&&((ex-x0)*(ex-x0)+(y1-y0)*(y1-y0)+(ze-z0)*(ze-z0))>=r0*r0));
  }
}

/* geosl - represent a sphere by a lissajous figure	*/
/* extending from pole to pole				*/

void geosl(r0,r,a0,l,m) double *r0, r, *a0; int l, m; {
int    i, n;
double d, th, ph, dt, dp, y0, o[3][3], w[3];
y0=r0[1];
n=2048;
th=0.0;
ph=0.0;
d=6.28318/((double)n);
dt=((double)l)*d;
dp=((double)m)*d;
spheu(o,a0);
sphrv(w,r,th,ph);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<n; i++) {
  th+=dt;
  ph+=dp;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],w[1]>=y0);
  }
}

/* geomsl - represent a sphere by a lissajous figure	*/
/* extending from pole to pole				*/

void geomsl(r0,r,a0,l,m,len) double *r0, r, *a0; int l, m, len; {
int    i;
double d, th, ph, dt, dp, y0, o[3][3], w[3];
y0=r0[1];
if (len==0) return;
th=0.0;
ph=0.0;
d=6.28318/((double)len);
dt=((double)l)*d;
dp=((double)m)*d;
spheu(o,a0);
sphrv(w,r,th,ph);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<len; i++) {
  th+=dt;
  ph+=dp;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],w[1]>=y0);
  }
}

/* geofr - represent a sphere by a fractal curve	*/

void geofr(r0,r,a0,l) double *r0, r, *a0; int l; {
int    g0, g1, g2, i, j, k, n;
double d, th, ph, y0, o[3][3], w[3], aa;
int    a[16]={0,1,0,5,3,4,0,1,1,0,4,3,5,0,1,0};
y0=r0[1];
if (l==0) return;
if (l==1) n=16*16*6;
if (l==2) n=16*6*6;
if (l==3) n=6*6*6;
if (l>3) return;
th=1.5707;
ph=0.0;
d=6.28318/((double)n);
spheu(o,a0);
sphrv(w,r,th,ph);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<16; i++) {
  g0=a[i];
  for (j=0; j<16; j++) {
    if (l>1) g1=a[j]; else g1=0;
    for (k=0; k<16; k++) {
      if (l>2) g2=a[k]; else g2=0;
      aa=((double)((g0+g1+g2)%6))*(6.28318/6.0);
      ph+=d*cos(aa); th+=0.866*d*sin(aa);
      sphrv(w,r,th,ph);
      sphap(w,o,w,r0);
      pltms(w[0],w[2],w[1]>=y0);
      }
    }
  }
}

/* geofs - represent a sphere by another fractal curve	*/

void geofs(r0,r,a0,l) double *r0, r, *a0; int l; {
int    g0, g1, g2, i, j, k, n;
double d, th, ph, y0, o[3][3], w[3], aa;
int    a[10]={0,5,4,2,0,0,2,4,5,0};
y0=r0[1];
if (l==0) return;
if (l==1) n=10*10*4;
if (l==2) n=10*4*4;
if (l==3) n=4*4*4;
if (l>3) return;
th=1.5707;
ph=0.0;
d=6.28318/(((double)n)*1.732);
spheu(o,a0);
sphrv(w,r,th,ph);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<10; i++) {
  g0=a[i];
  for (j=0; j<10; j++) {
    if (l>1) g1=a[j]; else g1=0;
    for (k=0; k<10; k++) {
      if (l>2) g2=a[k]; else g2=0;
      aa=((double)((2*g0+2*g1+2*g2+l)%12))*(6.28318/12.0);
      ph+=d*cos(aa); th+=0.866*d*sin(aa);
      sphrv(w,r,th,ph);
      sphap(w,o,w,r0);
      pltms(w[0],w[2],w[1]>=y0);
      }
    }
  }
}

/* geosp - scale spherical parameters */

void geosp(s,f,n) double s[][8], f; int n; {int i;
for (i=0; i<n; i++) {
	s[i][0]*=f;
	s[i][1]*=f;
	s[i][2]*=f;
	s[i][3]*=f; 
	s[i][7]*=f*f;
	}
}

/* geosr - scale spherical radii */

void geosr(s,f,n) double s[][8], f; int n; {int i;
for (i=0; i<n; i++) {s[i][3]*=f; s[i][7]*=f*f;}}

/* geoqr - square spherical radii */

void geoqr(t,s,n) double t[][8], s[][8]; int n; {int i;
sphcf(t,s,n); for (i=0; i<n; i++) t[i][3]=s[i][3]*s[i][3];}

/* georr - square root of spherical radii */

void georr(t,s,n) double t[][8], s[][8]; int n; {int i; double u;
sphcf(t,s,n);
for (i=0; i<n; i++) {u=s[i][3]; t[i][3]=(u>=0.0?sqrt(u):sqrt(-u));}}

/* geopc - represent a sphere by a projected circle */

void geopc(r0,r) double *r0, r; {
int    i, n;
double th, dh, ex, ze;
n=64;
th=0.0;
dh=6.28318/((double)(n-1));
ex=r*cos(th); ze=r*sin(th);
pltms(ex+r0[0],ze+r0[2],0);
for (i=0; i<n; i++) {
  th+=dh;
  ex=r*cos(th); ze=r*sin(th);
  pltms(r0[0]+ex,r0[2]+ze,1);
  }
}

/* fsipc - represent a sphere by a projected circle */

void fsipc(r0,r,l) double *r0, r; int l; {
int    i, n;
int i0, i1, i2;
double f, th, dh, ex, ze;
switch (l) {
  case 0: i0=0; i1=1; i2=2, f=-1.0; break;
  case 1: i0=1; i1=0; i2=2, f= 1.0; break;
  case 2: i0=0; i1=2; i2=1, f= 1.0; break;
  default: break;}
n=12;
th=0.0;
dh=6.28318/((double)(n-1));
ex=r*cos(th); ze=r*sin(th);
pltms(ex+r0[i0],ze+r0[i2],0);
for (i=0; i<n; i++) {
  th+=dh;
  ex=r*cos(th); ze=r*sin(th);
  pltms(r0[i0]+ex,r0[i2]+ze,1);
  }
}

/* geoss - represent a sphere by a spiral running from	*/
/* pole to pole						*/

void geoss(r0,r,a0) double *r0, r, *a0; {
int    i, n;
double g, th, dh, y0, o[3][3], w[3];
y0=r0[1];
n=2048;
g=64.0;
th=0.0;
dh=3.14159/((double)n);
spheu(o,a0);
sphrv(w,r,th,g*th);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<n; i++) {
  th+=dh;
  sphrv(w,r,th,g*th);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],w[1]<=y0?1:0);
  }
}

/* geomss - represent a sphere by a spiral running from	*/
/* pole to pole. This one has explicit parameters so    */
/* that they can be varied easily in demonstrations.    */
/* r0[3] center of sphere				*/
/* r     radius of sphere				*/
/* a0    orientation of axis				*/
/* pch   pitch of spiral = phi incr for each theta incr */
/* len   number of points (from pole to pole)		*/

void geomss(r0,r,a0,pch,len) double *r0, r, *a0; int pch, len; {
int    i;
double g, th, dh, y0, o[3][3], w[3];
y0=r0[1];
th=0.0;
g=(double)pch;
dh=3.14159/((double)len);
spheu(o,a0);
sphrv(w,r,th,g*th);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<len; i++) {
  th+=dh;
  sphrv(w,r,th,g*th);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],w[1]<=y0?1:0);
  }
}

/* fsiss - represent a sphere by a spiral running from	*/
/* pole to pole. This one has explicit parameters so    */
/* that they can be varied easily in demonstrations.    */
/* r0[3] center of sphere				*/
/* r     radius of sphere				*/
/* a0    orientation of axis				*/
/* pch   pitch of spiral = phi incr for each theta incr */
/* len   number of points (from pole to pole)		*/

void fsiss(r0,r,a0,pch,len) double *r0, r, *a0; int pch, len; {
int    i;
double g, th, dh, x0, y0, o[3][3], w[3];
x0=r0[0]; 
y0=r0[1];
th=0.0;
g=(double)pch;
dh=3.14159/((double)len);
spheu(o,a0);
sphrv(w,r,th,g*th);
sphap(w,o,w,r0);
  fsifdot(w[0],w[1],w[2],0,0);
for (i=0; i<len; i++) {
  th+=dh;
  sphrv(w,r,th,g*th);
  sphap(w,o,w,r0);
  fsifdot(w[0],w[1],w[2],w[1]<=y0?1:0,w[0]>=x0?1:0);
  }
}

/* stereoss - represent a sphere by a spiral running from	*/
/* pole to pole							*/

void stereoss(r0,r,a0) double *r0, r, *a0; {
int    i, n;
double g, th, dh, y0, o[3][3], w[3];
y0=r0[1];
n=2048;
g=64.0;
th=0.0;
dh=3.14159/((double)n);
spheu(o,a0);
sphrv(w,r,th,g*th);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<n; i++) {
  th+=dh;
  sphrv(w,r,th,g*th);
  sphap(w,o,w,r0);
  stereofdot(50.0*w[0],50.0*w[1],50.0*w[2],w[1]<=y0?1:0);
  }
}

/* pltil - interrupted line */

void pltil(x1,z1,q1,x2,z2,q2) double x1, z1, q1, x2, z2, q2; {
int    s1, s2;
double xm, zm;
s1=q1>0.0?1:0;
s2=q2>0.0?1:0;
if (s1!=s2) {
  xm=x1-q1*((x2-x1)/(q2-q1));
  zm=z1-q1*((z2-z1)/(q2-q1));
  pltms(xm,zm,s1);
  }
pltms(x2,z2,s2);
}

/* sphap - affine product			*/
/* w and z may be the same			*/
/* (vector w)=(matrix o)*(vector z)+(vector a)	*/

void sphap(w,o,z,a) double w[3], o[][3], z[3], a[3]; {
double u0, u1, u2;
u0=z[0]; u1=z[1]; u2=z[2];
w[0]=o[0][0]*u0+o[0][1]*u1+o[0][2]*u2+a[0];
w[1]=o[1][0]*u0+o[1][1]*u1+o[1][2]*u2+a[1];
w[2]=o[2][0]*u0+o[2][1]*u1+o[2][2]*u2+a[2];
}

/* sphau - augment one vector by another	*/
/* vector z = vector x + scalar f * vector y	*/

void sphau(z,x,f,y) double z[3], x[3], f, y[3]; {
z[0]=x[0]+f*y[0];
z[1]=x[1]+f*y[1];
z[2]=x[2]+f*y[2];
}

/* sphcv - copy vector */

void sphcv(z,x) double *z, *x; {z[0]=x[0]; z[1]=x[1]; z[2]=x[2];}

/* sphcf - copy sphere family */

void sphcf(z,x,n) double z[][8], x[][8]; int n; {
int i, j; for (i=0; i<n; i++) for (j=0; j<7; j++) z[i][j]=x[i][j];}

/* sphcm - copy matrix */

void sphcm(z,x) double z[3][3], x[3][3]; {
int i, j; for (i=0; i<3; i++) for (j=0; j<3; j++) z[i][j]=x[i][j];}

/* sphgv - negative vector */

void sphgv(z) double *z; {int i; for (i=0; i<3; i++) z[i]=-z[i];}

/* sphzv - zero vector */

void sphzv(z) double *z; {z[0]=z[1]=z[2]=0.0;}

/* sphzm - zero matrix */

void sphzm(z) double z[3][3]; {int i, j;
for (i=0; i<3; i++) for (j=0; j<3; j++) z[i][j]=0.0;
}

/* sphum - unit matrix */

void sphum(z) double z[3][3]; {int i, j;
for (i=0; i<3; i++) for (j=0; j<3; j++) z[i][j]=0.0;
for (i=0; i<3; i++) z[i][i]=1.0;
}

/* sphcl - clip matrix elements */

void sphcl(z,e) double z[][3], e; {int i, j; 
for (i=0; i<3; i++) for (j=0; j<3; j++) 
  if (z[i][j]>-e && z[i][j]<e) z[i][j]=0.0;
}

/* sphvs - vector sum */

void sphvs(z,x,y) double z[3], x[3], y[3]; {
z[0]=x[0]+y[0]; z[1]=x[1]+y[1]; z[2]=x[2]+y[2];}

/* sphvp - vector product */

void sphvp(z,x,y) double *z, *x, *y; {
z[0]=x[1]*y[2]-x[2]*y[1];
z[1]=x[2]*y[0]-x[0]*y[2];
z[2]=x[0]*y[1]-x[1]*y[0];
}

/* sphnv - normalize a non-sero vector */

void sphnv(z) double *z; {int i; double r;
r=z[0]*z[0]+z[1]*z[1]+z[2]*z[2];
if (r==0) return; else r=sqrt(r);
for (i=0; i<3; i++) z[i]/=r;
}

/* sphdj - distance to center j */

void sphdj(d1,d2,w,s,j) double *d1, *d2, *w, s[][8]; int j; {
double xx, yy, zz, rr;
xx=w[0]-s[j][0]; xx*=xx;
yy=w[1]-s[j][1]; yy*=yy;
zz=w[2]-s[j][2]; zz*=zz;
rr=s[j][3]; rr*=rr;
*d1=xx+yy+zz-rr;
*d2=xx+zz-rr;
}

/* sphax - generate rotation from axis and angle */

void sphax(o,th,a,b,c) double o[][3], th, a, b, c; {
double ca, cb, cc, ct, tt, st, r, t;
r=sqrt(a*a+b*b+c*c);
t=(th*3.14159)/180.0;
ca=a/r; cb=b/r; cc=c/r;
ct=cos(t); st=sin(t); tt=1.0-ct;
o[0][0]= ct+tt*ca*ca;
o[0][1]= cc*st+tt*ca*cb;
o[0][2]=-cb*st+tt*ca*cc;
o[1][0]=-cc*st+tt*ca*cb;
o[1][1]= ct+tt*cb*cb;
o[1][2]= ca*st+tt*cb*cc;
o[2][0]= cb*st+tt*ca*cb;
o[2][1]=-ca*st+tt*cb*cc;
o[2][2]= ct+tt*cc*cc;
}

/* sphar(o) calculates the rotation angle of matrix o */

double sphar(o) double o[3][3]; {double s;
s=o[0][0]+o[1][1]+o[2][2];
return((180.0*acos(0.5*(s-1.0)))/3.14159);
}

/* sphdc calculates the direction cosines of a rotation matrix */

void sphdc(a,o) double *a, o[3][3]; {double u, v, w, s; 
u=o[1][2]-o[2][1];
v=o[2][0]-o[0][2];
w=o[0][1]-o[1][0];
s=sqrt(u*u+v*v+w*w);
if (s>0.0) {a[0]=u/s; a[1]=v/s; a[2]=w/s;} else {sphzv(a); a[0]=1;}
}

void sphvc(a,x,y,z) double *a, x, y, z; {a[0]=x; a[1]=y; a[2]=z;}

/* spheu - generate rotation from euler angles	*/

void spheu(o,a) double o[][3], a[3]; {
double e0, e1, e2, c0, c1, c2, s0, s1, s2;

e0=(a[0]*3.14159)/180.0;
e1=(a[1]*3.14159)/180.0;
e2=(a[2]*3.14159)/180.0;
c0=cos(e0);
c1=cos(e1);
c2=cos(e2);
s0=sin(e0);
s1=sin(e1);
s2=sin(e2);
o[0][0]= c0*c2-s0*c1*s2;
o[0][1]=-c0*s2-s0*c1*c2;
o[0][2]= s0*s1;
o[1][0]= s0*c2+c0*c1*s2;
o[1][1]=-s0*s2+c0*c1*c2;
o[1][2]=-c0*s1;
o[2][0]= s1*s2;
o[2][1]= s1*c2;
o[2][2]= c1;
}

/* sphgeu - find the euler angles of a rotation */

void sphgeu(a,o) double *a, o[3][3]; {
int    i;
double e1, s1;
e1=acos(o[2][2]);
s1=sin(e1);
if (s1==0.0) {a[0]=acos(o[1][1]); a[1]=a[2]=0.0;}
    else {a[2]=acos(o[2][1]/s1); a[1]=e1; a[0]=acos(-o[1][2]/s1);}
for (i=0; i<3; i++) a[i]*=(180.0/3.14159);
}

/* sphrv - radius vector 		   */
/* cartesian vector from polar coordinates */

void sphrv(w,r,th,ph) double *w, r, th, ph; {double s;
s=r*sin(th);
w[0]=s*cos(ph);
w[1]=s*sin(ph);
w[2]=r*cos(th);
}

/* sphmm - matrix = matrix * matrix */

void sphmm(z,x,y) double z[3][3], x[3][3], y[3][3]; {
int    i, j, k;
double u[3][3], v[3][3];
sphcm(u,x); sphcm(v,y);
for (i=0; i<3; i++) for (j=0; j<3; j++) {
  z[i][j]=0.0; for (k=0; k<3; k++) z[i][j]+=u[i][k]*v[k][j];
  }
}

/* sphmv - vector = matrix * vector */

void sphmv(w,o,z) double *w, o[][3], *z; {
double u0, u1, u2;
u0=z[0]; u1=z[1]; u2=z[2];
w[0]=o[0][0]*u0+o[0][1]*u1+o[0][2]*u2;
w[1]=o[1][0]*u0+o[1][1]*u1+o[1][2]*u2;
w[2]=o[2][0]*u0+o[2][1]*u1+o[2][2]*u2;
}

/* make a jacobi rotation of the rows of the    */ 
/* matrix z through angle t in plane i, j       */
/* two columns will be affected                 */

void sphjr(z,i,j,th) double z[3][3]; int i, j; double th; {
int    k;
double c, s, t;
s=sin(th); c=cos(th);
for (k=0; k<3; k++) {
  t=z[k][i];
  z[k][i]= c*t+s*z[k][j];
  z[k][j]=-s*t+c*z[k][j];
  }
}

/* make a jacobi rotation of the columns of the */ 
/* matrix z through angle t in plane i, j       */
/* two rows will be affected                    */

void sphjc(z,i,j,th) double z[3][3]; int i, j; double th; {
int    k;
double c, s, t;
s=sin(th); c=cos(th);
for (k=0; k<3; k++) {
  t=z[i][k];
  z[i][k]= c*t+s*z[j][k];
  z[j][k]=-s*t+c*z[j][k];
  }
}

/* diagonalize a symmetric matrix and record its */
/* eigenvectors (using Jacobi's method).         */
/* u[3][3] = matrix of eigenvectors              */
/* v[3][3] = matrix being diagonalized           */

void sphji(u,v) double u[3][3], v[3][3]; {
int    i, j, k, l, ll;
double e, th;
for (i=0; i<3; i++) for (j=0; j<3; j++) u[i][j]=0.0;
for (i=0; i<3; i++) u[i][i]=1.0;
  ll=0;
for (k=0, e=1.0; k<10; k++, e/=3.0) {
  do {l=0;
    for (i=0; i<2; i++) for (j=i+1; j<3; j++) {
      ll++; if (ll>500) return;
      if(v[i][j]>-e&&v[i][j]<e) continue; 
      th=0.5*atan2(v[i][j]+v[j][i],v[i][i]-v[j][j]);
      sphjr(u,i,j,th); sphjr(v,i,j,th); sphjc(v,i,j,th);
      l=1;
      }
    }  while (l==1);
  }
 }

/* - - - - - - - - M O L E C U L E   P R O G R A M S - - - - - - - - */

/* molfc - generate a ferrocene molecule */
/* r1	iron radius			 */
/* r2   carbon radius			 */
/* r3	hydrogen radius			 */
/* r4   c-h bond			 */

void molfc(s,r1,r2,r3,r4) double s[][8], r1, r2, r3, r4; {
molpr(&s[0][0],1.0+r4,r3,1.3,30.0,30.0,30.0);	/* upper hydrogen ring	*/
molpr(&s[5][0],1.0,r2,1.0,30.0,30.0,30.0);	/* upper carbon ring	*/
s[10][0]=s[10][1]=s[10][2]=0.0; s[10][3]=r1;	/* iron atom		*/
s[10][4]=80.0; s[10][5]=-30.0; s[10][6]=100.0;
s[10][7]=r1*r1;
molps(&s[11][0],1.0,r2,-1.0,30.0,30.0,30.0);	/* lower carbon ring	*/
molps(&s[16][0],1.0+r4,r3,-1.3,30.0,30.0,30.0);	/* lower hydrogen ring  */
}

/* molpr - generate a pentagonal ring */
/* s[][8]  atom list	  */
/* r       radius of ring */
/* rr      radius of atom */
/* h       height         */
/* a,b,c   euler angles	  */

void molpr(s,r,rr,h,a,b,c) double s[][8], r, rr, h, a, b, c; {
int i;
double ph;
for (i=0, ph=0.0; i<5; i++,ph+=(72.0*3.14159)/180.0) {
  s[i][0]=r*cos(ph); s[i][1]=h; s[i][2]=r*sin(ph);
  s[i][3]=rr;
  s[i][4]=a; s[i][5]=b; s[i][6]=c;
  s[i][7]=rr*rr;
  }
}

/* molps - generate a staggered pentagonal ring */

void molps(s,r,rr,h,a,b,c) double s[][8], r, rr, h, a, b, c; {int i; double ph;
for (i=0, ph=(36.0*3.14159)/180.0; i<5; i++,ph+=(72.0*3.14159)/180.0) {
  s[i][0]=r*cos(ph); s[i][1]=h; s[i][2]=r*sin(ph);
  s[i][3]=rr;
  s[i][4]=a; s[i][5]=b; s[i][6]=c;
  s[i][7]=rr*rr;
  }
}

/* molhr - generate a hexagonal ring */

void molhr(s,r,rr,a,b,c) double s[][8], r, rr, a, b, c; {int i; double ph;
for (i=0, ph=0.0; i<6; i++,ph+=(60.0*3.14159)/180.0) {
  s[i][0]=r*cos(ph); s[i][1]=0.0; s[i][2]=r*sin(ph);
  s[i][3]=rr;
  s[i][4]=a; s[i][5]=b; s[i][6]=c;
  s[i][7]=rr*rr;
  }
}

/* molbe - generate a benzene molecule  */
/* s[12][8] parameter array		*/
/* ac       radius of carbon ring	*/
/* rc       radius of carbon atom	*/
/* ah       radius of hydrogen ring	*/
/* rh       radius of hydrogen atom	*/

void molbe(s,ac,rc,ah,rh) double s[][8], ac, rc, ah, rh; {
molhr(s[0],rc,ac, 30.0,50.0,40.0);
molhr(s[6],rh,ah,-60.0,40.0,30.0);
}

/* molsu - generate coordinates of a sulfur ring */

void molsu(s,bondsu,radsu,n) double s[][8], bondsu, radsu; int n; {int i;
for (i=0; i<n; i++) {
molsc(&s[i][0],&s[i][1],&s[i][2],bondsu,i,n);
s[i][3]=radsu;
s[i][4]=30.0;
s[i][5]=20.0;
s[i][6]=15.0;
s[i][7]=radsu*radsu;
}}

/* position an atom in a sulfur ring	*/
/*  p	position of the atom		*/
/*  n   number of atoms in the ring	*/
/*  d   radius of the ring		*/
/* al	angle between successive atoms	*/
/* be	bond angle between sulfur atoms	*/

void molsc(x,y,z,d,p,n) double *x, *y, *z, d; int p, n; {
double al, be, t;
// d=2.048;
al=6.2831852/((double) n);
be=(107.9*3.1415926)/360.0;
t=sin(be)/cos(al/2.0);
*x=d*sin(be)*cos(p*al)/sin(al);
*y=d*sin(be)*sin(p*al)/sin(al);
*z=(p%2==0?1.0:-1.0)*(d/2.0)*sqrt(1.0-t);
}

/* generate a monatomic polymer		*/
/* s[][8] atom list			*/
/*      d length of each bond		*/
/*     th degree angle between bonds	*/
/*     ta degree torsion angle		*/
/*      r atomic radius			*/
/*      n number of atoms		*/

void molmp(s,d,th,ta,r,n) double s[][8], d, th, ta, r; int n; {
int i;
double w[3];

th=(3.14159*(180.0-th))/180.0;
ta=(3.14159*ta)/180.0;

sphzv(s[0]);
s[0][3]=r;
s[0][7]=r*r;

if (n==1) return;
sphzv(s[1]);
s[1][0]=d;
s[1][3]=r;
s[1][7]=r*r;

if (n==2) return;
sphzv(s[2]);
s[2][0]=d*(1+cos(th));
s[2][1]=d*sin(th);
s[2][3]=r;
s[2][7]=r*r;

if (n==3) return;
for (i=3; i<n; i++) {
  mol4mp(s[i],s[i-3],s[i-2],s[i-1],d,th,ta);
  s[i][3]=r;
  s[i][7]=r*r;
  }
geodm(w,s,n);
sphgv(w);
geotf(s,w,n);
for (i=0; i<n; i++) {
  s[i][4]=45.0;
  s[i][5]=10.0*((double)i);
  s[i][6]=22.5;
  }
}

/* generate 3rd plus atom in a monatomic polymer */
/* z   present atom	*/
/* a   third previous	*/
/* b   second previous	*/
/* c   preceding atom	*/
/* r   atomic radius	*/
/* th  rad bond angle	*/
/* ta  rad torsion ang	*/

void mol4mp(z,a,b,c,r,th,ta) double *z, *a, *b, *c, r, th, ta; {
double u[3], v[3], x[3], y[3]; int i;
for (i=0; i<3; i++) u[i]=b[i]-a[i];
for (i=0; i<3; i++) v[i]=c[i]-b[i];
sphvp(x,u,v);
sphvp(y,x,v);
sphnv(v); sphnv(x); sphnv(y);
for (i=0; i<3; i++) 
	z[i]=c[i]+r*(cos(th)*v[i]+sin(th)*(sin(ta)*x[i]+cos(ta)*y[i]));
}

/* generate the skeletal array from the atom list */

void sulsq(sk,s,n) double sk[][3], s[][8]; int n; {int i, j;
for (i=0; i<n; i++) for (j=0; j<3; j++) sk[i][j]=s[i][j];
}

/* Generate a random assortment of n atoms */

void molra(s,n) double s[][8]; int n; {int i;
for (i=0; i<n; i++){
  s[i][0]=((double)(rand()%4096))/1024.0-2.0;
  s[i][1]=((double)(rand()%4096))/1024.0-2.0;
  s[i][2]=((double)(rand()%4096))/1024.0-2.0;
  s[i][3]=((double)(rand()%4096))/4096.0+0.1;
  s[i][4]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][5]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][6]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][7]=s[i][3]*s[i][3];
  }
}

/* Generate random parameters for the ith atom */

void molran(s,i) double s[][8]; int i; {
  s[i][0]=((double)(rand()%4096))/1024.0-2.0;
  s[i][1]=((double)(rand()%4096))/1024.0-2.0;
  s[i][2]=((double)(rand()%4096))/1024.0-2.0;
  s[i][3]=((double)(rand()%4096))/4096.0+0.1;
  s[i][4]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][5]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][6]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][7]=s[i][3]*s[i][3];
}

/* Fill a three dimensional lattice randomly */
/* p is probability in mils                  */
/* n is lattice width (not number of points) */

void molla(s,p,n) double s[][8]; int p, n; {
int    i, j, k, ii;
double dx;
  dx=3.0/((double)(n-1));
for (i=0; i<n; i++) for (j=0; j<n; j++) for (k=0; k<n; k++) {
  ii=i+n*(j+n*k);
  s[ii][0]=-1.5+((double)i)*dx;
  s[ii][1]=-1.5+((double)j)*dx;
  s[ii][2]=-1.5+((double)k)*dx;
  s[ii][3]=(rand()%1024)<p?0.4*dx:0.166;
  s[ii][4]=(((double)(rand()%4096))/4096.0)*180.0;
  s[ii][5]=(((double)(rand()%4096))/4096.0)*180.0;
  s[ii][6]=(((double)(rand()%4096))/4096.0)*180.0;
  s[ii][7]=s[ii][3]*s[ii][3];
}
}

/* spheres at the vertices of a tetrahedron */

void thedr(s) double s[][8]; {
int i;
  s[0][0]= 0.0;
  s[0][1]=-1.0;
  s[0][2]= 1.0;

  s[1][0]= 0.0;
  s[1][1]= 1.0;
  s[1][2]= 1.0;

  s[2][0]= 1.0;
  s[2][1]= 0.0;
  s[2][2]=-1.0;

  s[3][0]=-1.0;
  s[3][1]= 0.0;
  s[3][2]=-1.0;

for (i=0; i<4; i++) {
  s[i][3]=0.25+(((double)(rand()%4096))/4096.0)*0.82;
  s[i][4]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][5]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][6]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][7]=s[i][3]*s[i][3];
  }
}

/* spheres at the vertices of a regular tetrahedron */

void thon(s) double s[][8]; {
int i;
  s[0][0]= 0.0;
  s[0][1]=-1.0;
  s[0][2]= 1.0;
  s[0][3]= 0.5;

  s[1][0]= 0.0;
  s[1][1]= 1.0;
  s[1][2]= 1.0;
  s[1][3]= 0.5;

  s[2][0]= 1.0;
  s[2][1]= 0.0;
  s[2][2]=-1.0;
  s[2][3]= 0.5;

  s[3][0]=-1.0;
  s[3][1]= 0.0;
  s[3][2]=-1.0;
  s[3][3]= 0.5;

for (i=0; i<4; i++) {
  s[i][4]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][5]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][6]=(((double)(rand()%4096))/4096.0)*180.0;
  s[i][7]=s[i][3]*s[i][3];
  }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */


/* print the current option */

void twopc(k) char k; {
videocursor(0,2,2); printf("%c",k);
videocursor(0,2,2);
}

/* twopm - print the components of a matrix */

void twopm(z) double (*z)[4]; {int i, j;
printf("\n");
for (i=0; i<4; i++)  {
  for (j=0; j<4; j++)  printf("%6.2f  ",z[i][j]);
  printf("\n");
  }
}

/* twopf - print the components of a sphere family  */

void twopf(z,n) double z[][8]; int n; {int i, j;
printf("\n");
for (i=0; i<n; i++)  {
  for (j=0; j<7; j++)  printf("%6.2f  ",z[i][j]);
  printf("\n");
  }
}

/* twopv - print the components of a vector */

void twopv(z) double *z; {int i;
for (i=0; i<4; i++)  printf("%6.2f  ",z[i]);
printf("\n");
}

/* place a dot within range (-2.0, 2.0)	*/
/* at coordinate (x,y), color l		*/

void videoadot(x,y,l) double x, y; int l; {
videodot(199-(int)(42.5*y+100.0),(int)(50.0*x+160.0),l);}

/* Place a dot within range (-2.0, 2.0)	  */
/* at coordinate (x,y), visibility l.	  */
/* We need two versions of this function, */
/* according to whether it will be used   */
/* in DOS or NeXTSTEP. The former uses    */ 
/* videodot with integer coordinates but  */
/* the latter uses videofdot with double  */
/* coordinates.                           */

// void pltms(x,y,l) double x, y; int l; {int xx, yy;
// xx=(int)(50.0*x);
// yy=(int)(50.0*y);
// videodot(yy,xx,l);
// }

void pltms(x,y,l) double x, y; int l; {videofdot(50.0*y,50.0*x,l);}

void geoms(x,y,l) double x, y; int l; {
if (l) videodot(199-(int)(42.5*y+100.0),(int)(50.0*x+160.0),l);
}

void geomms(x,y,l,m) double x, y; int l, m; {int xx, yy;
if (!l) return;
xx=(int)(100.0*x+320.0); if (xx<0) xx=0; if (xx>640) xx=640;
yy=199-(int)(42.5*y+100.0); if (yy<0) yy=0; if (yy>200) yy=200;
videodot(yy,xx,m);
}


/* end geom.c */