
/* GEOM.H                                       */
/* Harold V. McIntosh, 14 December 1972         */
/* 10 November 1990 - "C" version	        */
/* 12 April 1992 - protototypes for Objective C */

void conth(double z[25][25][25], double c, int i, int j, int k, int vv);
void cudem(double f[25][25][25], int l, int m, int n, int v);
void elvji(double u[11][11], double v[11][11]);
void jbyji(double u[11][11][3][3], double v[11][11][3][3]);
void eomsf(double s[][8], int n);
void fsipc(double *r0, double r, int l);
void fsisf(double s[][8], int n, int l);
void fsiss(double *r0, double r, double *a0, int pch, int len);
void geoat(double s[][8], 
           double x, 
           double y, 
           double z, 
           double r, 
           double a, 
           double b, 
           double c, 
           int n);
void geoav(double s[][8], double x, double y, double z, double r, int n);
void geobo(int i);
void geobf(double s[][8], int b[12][12], int n);
void geoci(double s[][8]);
void geodax(double s[][8], double o[3][3], int n);
void geodi(int n);
void geodm(double *w, double s[][8], int n);
void geofr(double *r0, double r, double *a0, int l);
void geofs(double *r0, double r, double *a0, int l);
void geoii();
void geoil(double *p1, double q1, double *p2, double q2);
void geommain();
void geomms(double x, double y, int l, int m);
void geomp4(double z[][4], double x[][4], double y[][4]);
void geoms(double x, double y, int l);
void geomsf(double s[][8], int *t, int n);
void geoni(int n);
void geoome4(double z[][4], double x[][4]);
void geopi(int n);
void geoqi(int n);
void geoqm(double q[][3], double s[][8], int n);
void geoqr(double t[][8], double s[][8], int n);
void geori(int n);
void georf(double s[][8], double o[][3], int n);
void georr(double t[][8], double s[][8], int n);
void geosg(double *r0, double r, double *a0, int m, int l);
void geosi(double s[][8]);
void geosl(double *r0, double r, double *a0, int l, int m);
void geosr(double s[][8], double f, int n);
void geoss(double *r0, double r, double *a0);
void geosp(double s[][8], double f, int n);
void geomsg(double *r0, double r, double *a0, int m, int l, int la, int lo);
void geomsl(double *r0, double r, double *a0, int l, int m, int le);
void geomss(double *r0, double r, double *a0, int p, int l);
void molbe(double s[][8], double ac, double rc, double ah, double rh);
void molfc(double s[][8], double r1, double r2, double r3, double r4);
void molhr(double s[][8], double r, double rr, double a, double b, double c);
void molla(double s[][8], int p, int n);
void molmp(double s[][8], double d, double th, double ta, double r, int n);
void molpr(double s[][8], 
           double r, 
           double rr, 
           double h, 
           double a, 
           double b, 
           double c);
void molps(double s[][8], 
	   double r, 
	   double rr, 
           double h, 
           double a, 
           double b, 
           double c);
void molra(double s[][8], int n);
void molran(double s[][8], int i);
void molsc(double *x, double *y, double *z, double d, int p, int n);
void molsu(double s[][8], double radsu, double bondsu, int n);
void pltil(double x1, double z1, double q1, double x2, double z2, double q2);
void pltms(double x, double y, int l);
void shadsf(double s[][8], int *t, double u[3][3], int n);
void sphau(double *z, double *x, double f, double *y);
void sphap(double w[3], double o[][3], double z[3], double a[3]);
double sphar(double o[3][3]);
void sphax(double o[][3], double th, double a, double b, double c);
void sphcl(double z[][3], double e);
void sphcf(double z[][8], double x[][8], int n);
void sphcm(double z[3][3], double x[3][3]);
void sphcv(double *z, double *x);
void sphdc(double *a, double o[3][3]);
void sphdj(double *d1, double *d2, double *w, double s[][8], int j);
void spheu(double o[][3], double a[3]);
void sphgeu(double *a, double o[][3]);
void sphjc(double z[3][3], int i, int j, double th);
void sphji(double u[3][3], double v[3][3]);
void sphjr(double z[3][3], int i, int j, double th);
void sphmm(double z[3][3], double x[3][3], double y[3][3]);
void sphmv(double *w, double o[][3], double *z);
void sphrv(double *w, double r, double th, double ph);
void sphum(double z[3][3]);
void sphvc(double *a, double x, double y, double z);
void sphvs(double *z, double *x, double *y);
void sphzm(double z[3][3]);
void sphzv(double *z);
void sulsq(double sk[][3], double s[][8], int n);
void thedr(double s[][8]);
void thon(double s[][8]);
void twopc(int k);
void twopm(double (*z)[4]);
void twopv(double *z);
void videodot(int x, int y, int l);
void videoadot(double x, double y, int l);
void videofdot(double x, double y, int l);

void geomi4(double z[4][4], double u[4][4]);
int  geoge4(double p[4][4], int n);
void geocm4(double z[4][4], double x[4][4]);
void geoum4(double z[4][4]);
void geoxc4(double z[4][4], int i, int j);
void geoxr4(double z[4][4], int i, int j);
void geoxtc4(double p[4], double z[4][4], int n);
void geoac4(double z[4][4], int i, int j, double f, int k);
void geosm4(double z[4][4], double f, int i);
// void fifth(double ss[][8], double r, double t);
void fifth(double ss[][8], double r, double *t);

/* end geom.h */
