
/* GEOM.C */
/* Harold V. McIntosh, 14 December 1972 */
/* 10 November 1990 - "C" version	*/

/*# include "bdos.h"*/
# include "math.h"
# include "stdio.h"

# define COLGRAF     7  /* graph resolution			*/
# define T80X25      3  /* text resolution			*/
# define WHCYMAG     1  /* color quad for normal screen		*/
# define REDYEGR     2  /* color quad for normal screen		*/

# define DROWS		20	/* rows in demo menu	    */
# define DCOLS		32	/* second col in demo menu  */
# define PROWS		10	/* rows in parameter menu   */
# define PCOLS		20	/* cols in parameter menu   */
# define SROWS		20	/* rows in screen menu	    */
# define SCOLS		10 	/* column width in screen m */

# define NP          	 8	/* number of parameters &c  */
# define NS          	 2	/* number of screen options */


int    di, dj, pi, pj;				/* demo pointer, param ptr */
int    si, sj;					/* screen layout menu ptr  */
int    smen[NS];				/* screen menu options */
int    slim[NS];				/* screen menu limits */
int    dmii;					/* active demonstration */
int    bg;
int    tu[10], abe[12], afc[21];
int    bbe[12][12];
double pitc, leng;				/* pitch, length of spiral */
double radhy, radca, radfe, radsu;
double r0[3], r, a0[3], b0[3], uu[3][3];
double o[3][3], s[5][7], t[5][7], u[10][7];
double be[12][7], su[8][7], fc[21][7];

main() {
char   k;
int    i, j;

    videomode(COLGRAF);
    videoclear();
    videopalette(REDYEGR);
    videocursor(0,2,0);


k=' ';
di=9; dj=1;			/* demonstration menu (dj=1 or DCOLS) */
pi=6; pj=7;			/* parameter menu     */
si=0; sj=1;			/* screen format menu */
dmii=10;			/* active demonstration */
bg=17;
smen[0]=0; slim[0]=3;		/* x-y, y-z, or x-r main graph	   */
smen[1]=0; slim[1]=2;		/* parabolic/cartesian coordinates */
r0[0]=r0[1]=r0[2]=0.0;
a0[0]=a0[1]=a0[2]=45.0;
b0[0]=b0[1]=b0[2]=30.0;

pitc=86.0;
leng=2500.0;
videobackground(bg);

radhy=0.50; radca=0.75; radsu=1.00; radfe=1.45;

tu[0]=3; for (i=1; i<5; i++) tu[i]=1;  tu[5]=2;

for (i=0; i<6; i++) abe[i]=1; for (i=6; i<12; i++) abe[i]=2;

for (i=0; i<5; i++) afc[i]=2; for (i=5; i<10; i++) afc[i]=1; afc[10]=3;
for (i=11; i<16; i++) afc[i]=1; for (i=16; i<21; i++) afc[i]=2;

    geoat(s,-0.8, 0.0, 0.3, 1.6, 30.0, 40.0, 59.0, 0);
    geoat(s, 0.6, 0.2,-0.2, 1.0,-30.0,-95.0,-22.0, 1);

    geoat(t,-0.8, 0.0, 0.3, 1.6, 30.0, 40.0, 59.0, 0);
    geoat(t, 0.6,-0.8,-0.2, 0.7,-30.0,-95.0,-22.0, 1);
    geoat(t, 0.9, 0.5, 0.0, 1.6, 40.0,-75.0,-62.0, 0);

    geoat(u, 0.0, 1.8, 0.0, 1.25, -45.0, 45.0, 45.0, 0);
    geoat(u, 1.7, 0.0, 1.4, 0.47,  30.0, 50.0, 40.0, 1);
    geoat(u, 0.8, 0.0, 0.9, 0.47,  30.0, 50.0,-40.0, 2);
    geoat(u,-0.3, 0.0,-0.2, 0.47,  30.0, 50.0, 40.0, 3);
    geoat(u,-0.9, 0.0,-1.1, 0.47,  30.0, 50.0, 40.0, 4);
    geoat(u,-1.3, 0.2, 0.8, 0.36,  30.0, 50.0, 40.0, 5);

    molbe(be,radca,1.2*radca,radhy,1.8*radca);

    molsu(su,radsu); geosp(su,0.67,8);

    molfc(fc,radfe,radca,radhy);

for (i=0; i<12; i++) for (j=0; j<12; j++) bbe[i][j]=0;
for (i=0; i<6; i++) bbe[i][(i+1)%6]=1;
for (i=0; i<6; i++) bbe[i][i+6]=1;

while (1!=0) {
  videocursor(0,0,0); printf(" -GEOM-");
  tidat();
  di=dmii-1;
  pi=pj-1;
  spheu(uu,b0);
  videocursor(0,2,0); printf("? %1c",k);
   while (!kbdst()) videocursor(0,2,0);
   k=kbdin();
   if (k=='q') {videomode(T80X25); return;};
  videocursor(0,2,0); printf(" %1c ",k);
   switch (k) {

  /* demonstration menu with typical parameters and initial conditions */

  case '\273': case '#':			/* F1 key */
    dmii=dmenu();
    videomode(COLGRAF);
    videopalette(REDYEGR);
    break;

  /* parameter and initial condition menu activated for +,- */

  case '\274': case '$':			/* F2 key */
    pj=pmenu();    
    videomode(COLGRAF);
    videopalette(REDYEGR);
    break;

  /* */

  case '\275': case '%':			/* F3 key */
    sj=smenu();
    videomode(COLGRAF);
    videopalette(REDYEGR);			/* white/cyan/magenta */
    break;

  case '\322':					/* INSERT key */
    geopi(dmii);
    break;

  case '\323':					/* DELETE key */
    geopi(0);
    break;

  case '\307':					/* PAR UP key */
    pj--;
    if (pj==0) pj=PROWS;
    geoqi(pj);
    break;

  case '\317':					/* PAR DOWN key */
    if (pj>=PROWS) pj=0;
    pj++;
    geoqi(pj);
    break;

  case '\311':					/* PAGE UP key */
    dmii--;
    if (dmii==0) dmii=DROWS;
    geopi(dmii);
    break;

  case '\321':					/* PAGE DOWN key */
    if (dmii==DROWS) dmii=0;
    dmii++;
    geopi(dmii);
    break;

case 'a':					/* show skeleton */
    geoni(dmii);
    break;

case 'b':					/* draw bonds	 */
    geobo(dmii);
    break;

case 'c':
    eomsf(t,3);
    geosp(t,0.5,3);
    eomsf(t,3);
    geosr(t,2.0,3);
    break;

case 'd':
/*    eomsf(be,12); */
    break;

/* echo character from keyboard */

case 'e': 
    videocursor(0,0,35);
    printf("%1o",kbdin());
    break;

/* intersecting spheres */

case 'f':
    geosi(s);
    break;

case 'g':					/* draw molecule */
    geodi(dmii);
    break;

case 'h':
    geosg(r0,1.5,a0,14,8);
    break;

case 'i':
    geosl(r0,1.25,a0,14,17);
    break;

case 'j': geori(45.0,1.0,1.0,1.0,dmii); break;

case 'k': geori(60.0,1.0,1.0,1.0,dmii); break;

case 'l': geori(90.0,0.2,0.5,1.0,dmii); break;

case 'm': geori(90.0,1.0,0.3,0.2,dmii); break;

case 'n': geori(90.0,0.4,1.0,0.2,dmii); break;

/* read center of sphere */

case 'o':
    twopc('o');
    scanf("%F %F %F",&r0[0],&r0[1],&r0[2]);
    break;

/* read parameters */

case 'p':
    geoqi(pj);
/*    scanf("%F %F %F %F",&g1,&g2,&z1,&z2); */
    break;

/* read euler angles a0 */

case 'u':
    twopc('u');
    scanf("%F %F %F",&a0[0],&a0[1],&a0[2]);
    break;

/* read euler angles b0 */

case 'v':
    twopc('v');
    scanf("%F %F %F",&b0[0],&b0[1],&b0[2]);
    break;

/* set up background */

case 'w': videobackground(bg); break;

/* clear the screen */

case 'z':
    twopc('z');
    videomode(COLGRAF);
    videoclear();
    videopalette(REDYEGR);
    videobackground(bg);
    videocursor(0,2,0);
    break;

/* increase parameter */

case '+':
  switch (pj) {
    case 1: bg++; if (bg==32) bg=0; break;
    case 2: pitc*=1.125; break;
    case 3: leng*=1.414; break;
    case 4: radhy*=1.414; molfc(fc,radfe,radca,radhy); break;
    case 5: radca*=1.414; molfc(fc,radfe,radca,radhy); break;
    case 6: radsu*=1.250; molsu(su,radsu); geosp(su,0.67,8); break;
    case 7: radfe*=1.250; molfc(fc,radfe,radca,radhy); break;
    default: break;
      }
    geoqi(pj);
    break;

/* decrease parameter */

case '-':
  switch (pj) {
    case 1: if (bg==0) bg=32; bg--; break;
    case 2: pitc*=1.125; break;
    case 3: leng/=1.414; break;
    case 4: radhy/=1.414; molfc(fc,radfe,radca,radhy); break;
    case 5: radca/=1.414; molfc(fc,radfe,radca,radhy); break;
    case 6: radsu/=1.250; molsu(su,radsu); geosp(su,0.67,8); break;
    case 7: radfe/=1.250; molfc(fc,radfe,radca,radhy); break;
    default: break;
      }
    geoqi(pj);
    break;

/* go to next parameter with down arrow */

case '\320':
  twocur(pj); printf("=");
  if (pi==PROWS-1) pi=0; else pi++;
  pj=pi+1;
  break;

/* go to previous parameter with up arrow */

case '\310':
  twocur(pj); printf("=");
  if (pi==0) pi=PROWS-1; else pi--;
  pj=pi+1;
  break;

/* ? --- menu listing */

  case '?':
    twopc('?');
    videomode(COLGRAF);
    videopalette(REDYEGR);
    videocursor(0,9,0);
    printf(" F1 - demonstrations\n");
    printf(" F2 - parameters\n");
    printf(" ins - show demo\n");
    printf(" del - clear demo\n");
    printf(" pg up,dn change demo\n");
    printf(" q - quit\n");
    printf(" z - clear screen\n");
    printf(" ? - show menu\n");
    break;

  default: break;
  }  /* end switch */
}    /* end while  */

}  /* end main */

/* list of demonstration rules */
int dmenu() {int ii, jj; char c;
  videomode(T80X25);
  videocursor(0,0,0);  printf("Demonstrations for GEOM");
  videocursor(0,1,0);  printf(" 1 - sphere - spiral");
  videocursor(0,2,0);  printf(" 2 - sphere - lat and long");
  videocursor(0,3,0);  printf(" 3 - sphere - lissajous figure");
  videocursor(0,4,0);  printf(" 4 - pair of spheres");
  videocursor(0,5,0);  printf(" 5 - eclipse sequence");
  videocursor(0,7,0);  printf(" 6 - shadow sequence");
  videocursor(0,6,0);  printf(" 7 - benzene molecule C6H6");
  videocursor(0,8,0);  printf(" 8 - sulfur ring S8");
  videocursor(0,9,0);  printf(" 9 - ");
  videocursor(0,10,0);  printf("10 - ferrocene molecule Fe(CH)5");
  videocursor(0,11,0);  printf("11");
  videocursor(0,12,0);  printf("12");
  videocursor(0,13,0);  printf("13");
  videocursor(0,14,0);  printf("14");
  videocursor(0,15,0);  printf("15");
  videocursor(0,16,0);  printf("16");
  videocursor(0,17,0);  printf("17");
  videocursor(0,18,0);  printf("18");
  videocursor(0,19,0);  printf("19");
  videocursor(0,20,0);  printf("20");
  videocursor(0,1,DCOLS);  printf("21");
  videocursor(0,2,DCOLS);  printf("22");
  videocursor(0,3,DCOLS);  printf("23");
  videocursor(0,4,DCOLS);  printf("24");
  videocursor(0,5,DCOLS);  printf("25");
  videocursor(0,6,DCOLS);  printf("26");
  videocursor(0,7,DCOLS);  printf("27");
  videocursor(0,8,DCOLS);  printf("28");
  videocursor(0,9,DCOLS);  printf("29");
  videocursor(0,10,DCOLS);  printf("30");
  videocursor(0,11,DCOLS);  printf("31");
  videocursor(0,12,DCOLS);  printf("32");
  videocursor(0,13,DCOLS);  printf("33");
  videocursor(0,14,DCOLS);  printf("34");
  videocursor(0,15,DCOLS);  printf("35");
  videocursor(0,16,DCOLS);  printf("36");
  videocursor(0,17,DCOLS);  printf("37");
  videocursor(0,18,DCOLS);  printf("38");
  videocursor(0,19,DCOLS);  printf("39");
  videocursor(0,20,DCOLS);  printf("40");
  videocursor(0,22,0);  printf("move cursor with arrows, select with <cr>\n");
  videocursor(0,23,0);  printf("position at top with <, bottom with >.\n");
  ii=DROWS; jj=DCOLS; c='!'; /* ii = max # rows, jj = second column */
  do {
    videocursor(0,di+1,dj);
    while (!kbdst()) videocursor(0,di+1,dj);
    c=kbdin();
      switch (c) {
      case '\013': case '\310': if (di==0) di=ii-1; else di--; break; /* up arrow */
      case '\012': case '\320': if (di==ii-1) di=0; else di++; break; /* down arrow */
      case '\014': case '\315': case ' ': dj=(dj==1?jj:1); break;     /* forward */
      case '\010': case '\313': dj=(dj==1?jj:1); break;		      /* backward */
      case '<': di=0; break;					      /* home */
      case '>': di=ii-1; break;					      /* bottom */
      default: break;
      }
    } while (c!='\015');
  return(di+ii*(dj==1?0:1)+1);
}

/* list of parameters and initial conditions */
int pmenu() {int ii; char c;
videomode(T80X25);
videocursor(0,0,0);  printf("Parameters and initial conditions for GEOM");
videocursor(0,1,0);  printf(" 1 - background color (%2d)",bg);
videocursor(0,2,0);  printf(" 2 - pitch of atomic spiral (%4.2f)",pitc);
videocursor(0,3,0);  printf(" 3 - length of atomic spiral (%6.0f)",leng);
videocursor(0,4,0);  printf(" 4 - radius of H atom (%4.2f)",radhy);
videocursor(0,5,0);  printf(" 5 - radius of C atom (%4.2f)",radca);
videocursor(0,6,0);  printf(" 6 - radius of S atom (%4.2f)",radsu);
videocursor(0,7,0);  printf(" 7 - radius of Fe atom (%4.2f)",radfe);
videocursor(0,8,0);  printf(" 8");
videocursor(0,9,0);  printf(" 9");
videocursor(0,10,0); printf("10");
videocursor(0,11,0); printf("11");
videocursor(0,12,0); printf("12");
videocursor(0,13,0); printf("13");
videocursor(0,14,0); printf("14");
videocursor(0,15,0); printf("15");
videocursor(0,16,0); printf("16");
videocursor(0,17,0); printf("17");
videocursor(0,18,0); printf("18");
videocursor(0,19,0); printf("19");
videocursor(0,20,0); printf("20");
  videocursor(0,22,0);  printf("move cursor with arrows, select with <cr>\n");
  videocursor(0,23,0);  printf("position at top with <, bottom with >.\n");
  ii=PROWS; c='!'; /* ii = max # rows */
  do {
    videocursor(0,pi+1,1);
    while (!kbdst()) videocursor(0,pi+1,1);
    c=kbdin();
      switch (c) {
      case '\013': case '\310': if (pi==0) pi=ii-1; else pi--; break; /* up arrow */
      case '\012': case '\320': if (pi==ii-1) pi=0; else pi++; break; /* down arrow */
      case '<': pi=0; break;					      /* home */
      case '>': pi=ii-1; break;					      /* bottom */
      default: break;
      }
    } while (c!='\015');
  return(pi+1);
}

/* list of screen positions and options */
int smenu() {int ii, jj; char c;
  videomode(T80X25);
  videocursor(0,0,0);  printf("");
  videocursor(0,1,0);  printf(" 1");
  videocursor(0,2,0);  printf(" 2");
  videocursor(0,3,0);  printf(" 3");
  videocursor(0,4,0);  printf(" 4");
  videocursor(0,5,0);  printf(" 5");
  videocursor(0,6,0);  printf(" 6");
  videocursor(0,7,0);  printf(" 7");
  videocursor(0,8,0);  printf(" 8");
  videocursor(0,9,0);  printf(" 9");
  videocursor(0,10,0);  printf("10");
  videocursor(0,11,0);  printf("11");
  videocursor(0,12,0);  printf("12");
  videocursor(0,13,0);  printf("13");
  videocursor(0,14,0);  printf("14");
  videocursor(0,15,0);  printf("15");
  videocursor(0,16,0);  printf("16");
  videocursor(0,17,0);  printf("17");
  videocursor(0,18,0);  printf("18");
  videocursor(0,19,0);  printf("19");
  videocursor(0,20,0);  printf("20");
  videocursor(0,22,0);  printf("move cursor with arrows, select with <cr>\n");
  videocursor(0,23,0);  printf("position at top with <, bottom with >.\n");
  ii=SROWS; jj=SCOLS; c='!'; /* ii = max # rows, jj = second column */
  do {
    sj=smen[si];
    videocursor(0,si+1,sj*jj);
    while (!kbdst()) videocursor(0,si+1,sj*jj);
    c=kbdin();
      switch (c) {
      case '\013': case '\310':
	if (si==0) si=ii-1; else si--; break;			/* up arrow */
      case '\012': case '\320':
	if (si==ii-1) si=0; else si++; break;			/* down arrow */
      case '\014': case '\315': case ' ':
	sj++; if (sj==slim[si]) sj=0; smen[si]=sj; break;	/* forward */
      case '\010': case '\313':
	if (sj==0) sj=slim[si]; sj--; smen[si]=sj; break;	/* backward */
      case '<':
	si=0; break;						/* home */
      case '>':
	si=ii-1; break;						/* bottom */
      default:
	break;
      }
    } while (c!='\015');
  return(si+1);
}

/* keyboard status */
int kbdst() {return(bdos(11) & 0xFF);}

/* direct keyboard input, no echo */
kbdin() {int c;
  if ((c = bdos(7) & 0xFF) == '\0') c = (bdos(7) & 0xFF) | 0x80;
  return(c);
}

/* read number from keyboard */
int numin(n) int n; {char c;
  c=kbdin();
  if (c>='0'&&c<='9') return(numin(10*n+(c-'0'))); else return(n);
}

/* place time and date on screen */ 

tidat() {long clock[1];
videocursor(0,0,8); time(clock); printf("%26s",ctime(clock));
}

/* complex z = sqrt(x) */

csqrt(z,x) double *z, *x; {
double sqrt(), q, r, u, v;
q=x[1];
r=sqrt(x[0]*x[0]+x[1]*x[1]);
u=0.5*(r+x[0]);
v=0.5*(r-x[0]);
z[0]=sqrt(u);
z[1]=sqrt(v);
if (q<0.0) z[0]=-z[0];
}

/* @tanh.c */
/* #include	<errno.h> */

#define	P0	-0.161341190239962e4
#define	P1	-0.992259296722360e2
#define	P2	-0.964374927772254
#define	Q0	0.484023570719886e4
#define	Q1	0.223377207189623e4
#define	Q2	0.112744743805349e3

#define	XBIG		(27 * 0.693147180559945)
#define	LN3OVER2	0.549306144334054

double	fabs();
double	exp();

double	tanh(x)
	double	x;
	{
	double	f;
	double	g;
	double	pg, qg;

	f = fabs(x);
	if	(f > XBIG)
		f = 1.0;
	else if	(f > LN3OVER2){
		f = 0.5 - 1.0 / (exp(f + f) + 1.0);
		f = f + f;
		}
	else if	(f > 1e-8){
		g = f * f;
		pg = P0 + g * (P1 + g * P2);
		qg = Q0 + g * (Q1 + g * (Q2 + g));
		f = f + f * (g * (pg / qg));;
		}
	if	(x < 0)
		f = -f;
	return(f);
	}

/* make a frame for a graph 		 */
/* (x,y) = lower left corner; e.g. (0,0) */
/* n     = dimension of frame            */

gfram(x,y,n) int x, y, n; {int i;

for (i=0; i<=n; i++) videodot(199-y-i,x,0);
for (i=0; i<=n; i++) videodot(199-y-i,x+n,0);
for (i=0; i<=n; i++) videodot(199-n-y,x+i,0);
for (i=0; i<=n; i++) videodot(199-y,x+i,0);

for (i=0; i<=n; i+=10) videodot(199-y-i,x,3);
for (i=0; i<=n; i+=10) videodot(199-y-i,x+n,3);
for (i=0; i<=n; i+=10) videodot(199-n-y,x+i,3);
for (i=0; i<=n; i+=10) videodot(199-y,x+i,3);
}

/* put a diagonal in a graph */

gdiag(x,y,n) int x, y, n; {int i;
for (i=0; 2*i<n; i++) videodot(199-y-2*i,x+2*i,3);
}

/* geobf - bonds in a family of spheres */

geobf(s,b,n) double s[][7]; int b[12][12], n; {
int    i, j, k, l, m, mm;
double b1, b2, dx, dy, dz;
double em, p[3];
mm=100;
em=((double)mm);
for (i=0; i<n; i++) for (j=0; j<n; j++) {
  if (b[i][j]==0) continue;
  p[0]=s[i][0]; dx=(s[j][0]-s[i][0])/em;
  p[1]=s[i][1]; dy=(s[j][1]-s[i][1])/em;
  p[2]=s[i][2]; dz=(s[j][2]-s[i][2])/em;
  for (k=0; k<mm; k++) {
    m=1;
    for (l=0; l<n; l++) {
      sphdj(&b1,&b2,p,&s[l][0],s[l][3]);
      if (b1<0.0)        {m=0; break;}
      if (p[1]<=s[l][1]) continue;
      if (b2<=0.0)       {m=0; break;}
      }  /* end for l */
    pltms(p[0],p[2],m);
    p[0]+=dx; p[1]+=dy; p[2]+=dz;
    }  /* end for k   */
  }    /* end for i,j */
}

/* geobo - draw bonds for family i */

geobo(i) int i; {
switch (i) {
case  1: break;
case  2: break;
case  3: break;
case  4: break;
case  5: break;
case  6: break;
case  7: geosr(be,0.20,12); geobf(be,bbe,12); geosr(be,5.0,12); break;
case  8: break;
case  9: break;
case 10: break;
default: break;
}}

/* geodi - display spheres from family i */

geodi(i) int i; {
switch (i) {
case  1: geoss(r0,1.75,a0); break;
case  2: geosg(r0,1.5,a0,14,8); break;
case  3: geosl(r0,1.25,a0,14,17); break;
case  4: geosi(s); break;
case  5: geomsf(u,tu,6); break;
case  6: shadsf(u,tu,uu,6); break;
case  7: geomsf(be,abe,12); break;
case  8: eomsf(su,8); break;
case  9: break;
case 10: geomsf(fc,afc,21); break;
default: break;
}}

/* calculate dipole moment */

geodm(w,s,n) double w[3], *s[7]; int n; {
double en; int i;
en=(double)n;
w[0]=w[1]=w[2]=0.0;
for (i=0; i<n; i++) {w[0]+=s[0][i]; w[1]+=s[1][i];w[2]+=s[2][i];}
w[0]/=en; w[1]/=en; w[2]/=en;
}

/* geoil - interrupted line */

geoil(p1,q1,p2,q2) double *p1, q1, *p2, q2; {
double x1, z1, x2, z2;
x1=p1[0];
z1=p1[2];
x2=p2[0];
z2=p2[2];
if (q1<0.0) {
  if (q2<0.0) {pltms(x2,z2,0); return;} else {
    x1=x1-q1*((x2-x1)/(q2-q1));
    z1=z1-q1*((z2-z1)/(q2-q1));
    geoms(x1,z1,1,0);
    geoms(z2,z2,1,1);
    return;
    }
  } else {
  if (q2>0.0) {pltms(x2,z2,1); return;} else {
    x1=x1-q1*((x2-x1)/(q2-q1));
    z1=z1-q1*((z2-z1)/(q2-q1));
    geoms(x1,z1,1,1);
    geoms(z2,z2,1,0);
    return;
    }
  }
}

/* geoni - show the nuclei of the spheres from family i */

geoni(i) int i; {
switch (i) {
case  1: break;
case  2: break;
case  3: break;
case  4: geosr(s,0.20, 6); geosi(s); geosr(s,5.0, 6); break;
case  5: geosr(u,0.20, 6); eomsf(u, 6); geosr(u,5.0, 6); break;
case  6: geosr(u,0.20, 6); eomsf(u, 6); geosr(u,5.0, 6); break;
case  7: geosr(be,0.20,12); geomsf(be,abe,12); geosr(be,5.0,12); break;
case  8: geosr(su,0.20,8); eomsf(su,8); geosr(su,5.0,8); break;
case  9: break;
case 10: geosr(fc,0.20,21); geomsf(fc,afc,21); geosr(fc,5.0,8); break;
default: break;
}}

/* geopi - print the name of family i */

geopi(i) int i; {
videocursor(0,24,0);
printf("                  ");
videocursor(0,24,0);
switch (i) {
case  0: printf("                  "); break;
case  1: printf("sphere - spiral"); break;
case  2: printf("sphere - lat, long"); break;
case  3: printf("sphere - lissaj"); break;
case  4: printf("pair of spheres"); break;
case  5: printf("planetary eclipse"); break;
case  6: printf("shadow sequence"); break;
case  7: printf("benzene ring"); break;
case  8: printf("sulfur molecule"); break;
case  9: printf("-9-"); break;
case 10: printf("ferrocene molecule"); break;
default: break;}
videocursor(0,2,0);
}

/* geoqi - print the name of ith parameter */

geoqi(i) int i; {
videocursor(0,24,21);
printf("                  ");
videocursor(0,24,21);
switch (i) {
case  0: printf("                  "); break;
case  1: printf("screen color (%2d)",bg); break;
case  2: printf("pitch  (%6.0f)",pitc); break;
case  3: printf("length  (%6.0f)",leng); break;
case  4: printf("hydrogen (%4.2f)",radhy); break;
case  5: printf("carbon (%4.2f)",radca); break;
case  6: printf("sulfur (%4.2f)",radsu); break;
case  7: printf("iron (%4.2f)",radfe); break;
default: break;}
videocursor(0,2,0);
}

/* geori - rotate spheres from family i by */
/* angle t about axis (a,b,c)		   */
		
geori(t,a,b,c,i) double t, a, b, c; int i; {double o[3][3];
sphax(o,t,a,b,c);
switch (i) {
case  1: break;
case  2: break;
case  3: break;
case  4: georf(s,o,2);   break;
case  5: georf(u,o,6);   break;
case  6: georf(u,o,6);   break;
case  7: georf(be,o,12); break;
case  8: georf(su,o,8);  break;
case  9: break;
case 10: georf(fc,o,21); break;
default: break;
}}

/* eomsf - intersection of a family of spheres */

eomsf(s,n) double s[][7]; int n; {
int    i, j, k, m, mi;
double b1, b2, g, th, dh, ri;
double emi, p[3], o[3][3];
g=57.0;
for (i=0; i<n; i++) {
  ri=s[i][3];
  emi=2000.0*ri;
  mi=(int)emi;
  dh=3.14159/emi;
  th=0.0;
  spheu(o,&s[i][4]);
  for (k=0; k<mi; k++) {
    th+=dh;
    sphrv(p,ri,th,g*th);
    sphap(p,o,p,&s[i][0]);
    if  (p[1]>s[i][1]) continue;
    m=1;
    for (j=0; j<n; j++) {
      if (i==j) continue;
      sphdj(&b1,&b2,p,&s[j][0],s[j][3]);
      if (b1<0.0)        {m=0; break;}
      if (p[1]<=s[j][1]) continue;
      if (b2<=0.0)       {m=0; break;}
      }  /* end for j */
    pltms(p[0],p[2],m);
    }  /* end for k */
  }    /* end for i */
}

/* geomsf - present a family of spheres in color */

geomsf(s,t,n) double s[][7]; int *t, n; {
int    i, j, k, m, mi;
double b1, b2, g, th, dh, ri;
double emi, p[3], o[3][3];
g=pitc;
for (i=0; i<n; i++) {
  ri=s[i][3];
  emi=leng*ri;
  mi=(int)emi;
  dh=3.14159/emi;
  th=0.0;
  spheu(o,&s[i][4]);
  for (k=0; k<mi; k++) {
    th+=dh;
    sphrv(p,ri,th,g*th);
    sphap(p,o,p,&s[i][0]);
    if  (p[1]>s[i][1]) continue;
    m=1;
    for (j=0; j<n; j++) {
      if (i==j) continue;
      sphdj(&b1,&b2,p,&s[j][0],s[j][3]);
      if (b1<0.0)        {m=0; break;}
      if (p[1]<=s[j][1]) continue;
      if (b2<=0.0)       {m=0; break;}
      }  /* end for j */
    geoms(p[0],p[2],m,t[i]);
    }  /* end for k */
  if (kbdst()) {kbdin(); break;}
  }    /* end for i */
}

/* shadsf - present a family of spheres in color */
/* s[n][7] - family of spheres			 */
/* u[3][3] - direction of shadow		 */
/* t[n] -    color codes			 */

shadsf(s,t,u,n) double s[][7], u[3][3]; int *t, n; {
int    i, j, k, m, mi;
double b1, b2, g, th, dh, ri;
double emi, p[3], q[3], a[3], b[3], o[3][3];
g=pitc;
for (i=0; i<n; i++) {
  ri=s[i][3];
  emi=leng*ri;
  mi=(int)emi;
  dh=3.14159/emi;
  th=0.0;
  spheu(o,&s[i][4]);
  for (k=0; k<mi; k++) {
    th+=dh;
    sphrv(a,ri,th,g*th);
    sphmv(p,o,a);
    if (p[1]>0.0) continue;
    sphmv(q,u,p);
    if (q[1]>0.0) continue;
    sphvs(p,p,&s[i][0]);
    sphmv(b,u,p);
    m=1;
    for (j=0; j<n; j++) {
      if (i==j) continue;
      sphdj(&b1,&b2,p,&s[j][0],s[j][3]);
      if (b1<0.0)        {m=0; break;}
      if (p[1]<=s[j][1]) continue;
      if (b2<=0.0)       {m=0; break;}
      sphmv(q,u,&s[j][0]);
      sphdj(&b1,&b2,b,q,s[j][3]);
      if (b1<0.0)        {m=0; break;}
      if (b[1]<=q[1])    continue;
      if (b2<=0.0)       {m=0; break;}
      }  /* end for j */
    geoms(p[0],p[2],m,m);
    }  /* end for k */
  if (kbdst()) {kbdin(); break;}
  }    /* end for i */
}

/* georf - rotated family */

georf(s,o,n) double s[][7], o[][3]; int n; {
int i;
for (i=0; i<n; i++) sphmv(&s[i][0],o,&s[i][0]);
}

/* geoat - insert all seven atomic values into chain */

geoat(s,x,y,z,r,a,b,c,n) double s[][7], x, y, z, r, a, b, c; int n; {
s[n][0]=x;
s[n][1]=y;
s[n][2]=z;
s[n][3]=r;
s[n][4]=a;
s[n][5]=b;
s[n][6]=c;
}

/* geoav - insert atomic values into chain */

geoav(s,x,y,z,r,n) double s[][7], x, y, z, r; int n; {
s[n][0]=x;
s[n][1]=y;
s[n][2]=z;
s[n][3]=r;
s[n][4]=45.0;
s[n][5]=45.0;
s[n][6]=45.0;
}

/* geosg - represent a sphere by latitude and longitude	*/

geosg(r0,r,a0,m,l) double *r0, r, *a0; int m, l; {
int    i, j;
double th, ph, dt, dp, y0;
double o[3][3], w[3];

y0=r0[1];
spheu(o,a0);
dt=3.14159/((double)(l+1));
dp=0.0628318;
th=3.14159-dt;
for (i=0; i<l; i++,th-=dt) {
  ph=0.0;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],0);
  for (j=0; j<100; j++) {
    ph+=dp;
    sphrv(w,r,th,ph);
    sphap(w,o,w,r0);
    pltms(w[0],w[2],w[1]>=y0);
    }}
dt=0.0628318;
dp=3.14159/((double)m);
for (i=0,ph=0.0; i<m; i++,ph+=dp) {
for (j=0,th=0.0; j<100; j++) {
  th+=dt;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],w[1]>=y0);
  }}
}

/* geosi - intersection of two spheres */

geosi(s) double s[][7]; {
int    i, j, k, n, m, m0;
double b1, b2, c1, c2, g, th, dh, ri;
double xx, yy, zz, rr;
double w[3], u[3], o[3][3];
n=4096;
n=2048;
g=128.0;
g=64.0;
g=53.0;
dh=3.14159/((double)n);
for (i=0; i<2; i++) 
for (j=0; j<2; j++) {
  if (i==j) continue;
  th=0.0;
  ri=s[i][3];
/*  twopv(&s[i][0]); */
/*  twopv(&s[i][4]); */
  spheu(o,&s[i][4]);
/*  twopm(o); */
  sphrv(w,ri,th,g*th);
  sphap(u,o,w,&s[i][0]);
  c1=-1.0;
  c2=-1.0;
  m0=3;
  pltms(u[0],u[2],0);
  for (k=0; k<n; k++) {
    th+=dh;
    sphrv(w,ri,th,g*th);
    sphap(w,o,w,&s[i][0]);
    xx=w[0]-s[j][0]; xx*=xx;
    yy=w[1]-s[j][1]; yy*=yy;
    zz=w[2]-s[j][2]; zz*=zz;
    rr=s[j][3]; rr*=rr;
    b2=xx+zz-rr;
    b1=b2+yy;
    m=3;
    if      (s[i][1]<w[1]) m0=4;
    else if (b1<0.0) {m=1; m0=1;}
    else if (w[1]<=s[j][1]) m0=3;
    else if (b2>=0.0) m0=3;
    else    m=2;
    switch (m0) {
      case 1: pltil(u[0],u[2],c1,w[0],w[2],b1,i+1); break;
      case 2: pltil(u[0],u[2],c2,w[0],w[2],b2,i+1); break;
      case 3: pltil(u[0],u[2],1.0,w[0],w[2],1.0,i+1); break;
      case 4: pltil(u[0],u[2],-1.0,w[0],w[2],-1.0,i+1); break;
      case 5: geoms(w[0],w[2],1,i+1); break;
      default: break;
      }

    u[0]=w[0]; u[1]=w[1]; u[2]=w[2];
    c1=b1;
    c2=b2;
    m0=m;
    }  /* end for k */
  }    /* end for j */
}

/* geosl - represent a sphere by a lissajous figure	*/
/* extending from pole to pole				*/

geosl(r0,r,a0,l,m) double *r0, r, *a0; int l, m; {
int    i, n;
double d, th, ph, dt, dp, y0, o[3][3], w[3];
y0=r0[1];
n=2048;
th=0.0;
ph=0.0;
d=6.28318/((double)n);
dt=((double)l)*d;
dp=((double)m)*d;
spheu(o,a0);
sphrv(w,r,th,ph);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<n; i++) {
  th+=dt;
  ph+=dp;
  sphrv(w,r,th,ph);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],w[1]>=y0);
  }
}

/* geosp - scale spherical parameters */

geosp(s,f,n) double s[][7], f; int n; {int i;
for (i=0; i<n; i++) {s[i][0]*=f; s[i][1]*=f; s[i][2]*=f; s[i][3]*=f;}}

/* geosr - scale spherical radii */

geosr(s,f,n) double s[][7], f; int n; {int i;
for (i=0; i<n; i++) s[i][3]*=f;}

/* geoss - represent a sphere by a spiral running from	*/
/* pole to pole						*/

geoss(r0,r,a0) double *r0, r, *a0; {
int    i, n;
double g, th, dh, y0, o[3][3], w[3];
y0=r0[1];
n=2048;
g=64.0;
th=0.0;
dh=3.14159/((double)n);
spheu(o,a0);
sphrv(w,r,th,g*th);
sphap(w,o,w,r0);
pltms(w[0],w[2],0);
for (i=0; i<n; i++) {
  th+=dh;
  sphrv(w,r,th,g*th);
  sphap(w,o,w,r0);
  pltms(w[0],w[2],w[1]>=y0?1:0);
  }
}

/* pltil - interrupted line */

pltil(x1,z1,q1,x2,z2,q2,l) double x1, z1, q1, x2, z2, q2; int l; {
int    s1, s2;
double xm, zm;
s1=q1>0.0?1:0;
s2=q2>0.0?1:0;
if (s1!=s2) {
  xm=x1-q1*((x2-x1)/(q2-q1));
  zm=z1-q1*((z2-z1)/(q2-q1));
  geoms(xm,zm,s1,l);
  }
geoms(x2,z2,s2,l);
}

/* sphap - affine product			*/
/* w and z may be the same			*/
/* (vector w)=(matrix o)*(vector z)+(vector a)	*/

sphap(w,o,z,a) double w[3], o[][3], z[3], a[3]; {
double u0, u1, u2;
u0=z[0]; u1=z[1]; u2=z[2];
w[0]=o[0][0]*u0+o[0][1]*u1+o[0][2]*u2+a[0];
w[1]=o[1][0]*u0+o[1][1]*u1+o[1][2]*u2+a[1];
w[2]=o[2][0]*u0+o[2][1]*u1+o[2][2]*u2+a[2];
}

/* sphau - augment one vector by another	*/
/* vector z = vector x + scalar f * vector y	*/

sphau(z,x,f,y) double z[3], x[3], f, y[3]; {
z[0]=x[0]+f*y[0];
z[1]=x[1]+f*y[1];
z[2]=x[2]+f*y[2];
}

/* sphcv - copy vector */

sphcv(z,x) double *z, *x; {z[0]=x[0]; z[1]=x[1]; z[2]=x[2];}

/* sphdj - distance to center j */

sphdj(d1,d2,w,x,rj) double *d1, *d2, *w, *x, rj; {
double xx, yy, zz, rr;
xx=w[0]-x[0]; xx*=xx;
yy=w[1]-x[1]; yy*=yy;
zz=w[2]-x[2]; zz*=zz;
rr=rj; rr*=rr;
*d1=xx+yy+zz-rr;
*d2=xx+zz-rr;
}

/* sphax - generate rotation from axis and angle */

sphax(o,th,a,b,c) double o[][3], th, a, b, c; {
double ca, cb, cc, ct, tt, st, r, t;
r=sqrt(a*a+b*b+c*c);
t=(th*3.14159)/180.0;
ca=a/r; cb=b/r; cc=c/r;
ct=cos(t); st=sin(t); tt=1.0-ct;
o[0][0]= ct+tt*ca*ca;
o[0][1]= cc*st+tt*ca*cb;
o[0][2]=-cb*st+tt*ca*cc;
o[1][0]=-cc*st+tt*ca*cb;
o[1][1]= ct+tt*cb*cb;
o[1][2]= ca*st+tt*cb*cc;
o[2][0]= cb*st+tt*ca*cb;
o[2][1]=-ca*st+tt*cb*cc;
o[2][2]= ct+tt*cc*cc;
}

/* spheu - generate rotation from euler angles	*/

spheu(o,a) double o[][3], a[3]; {
double e0, e1, e2, c0, c1, c2, s0, s1, s2;

e0=(a[0]*3.14159)/180.0;
e1=(a[1]*3.14159)/180.0;
e2=(a[2]*3.14159)/180.0;
c0=cos(e0);
c1=cos(e1);
c2=cos(e2);
s0=sin(e0);
s1=sin(e1);
s2=sin(e2);
o[0][0]= c0*c2-s0*c1*s2;
o[0][1]=-c0*s2-s0*c1*c2;
o[0][2]= s0*s1;
o[1][0]= s0*c2+c0*c1*s2;
o[1][1]=-s0*s2+c0*c1*c2;
o[1][2]=-c0*s1;
o[2][0]= s1*s2;
o[2][1]= s1*c2;
o[2][2]= c1;
}

/* sphrv - radius vector 		   */
/* cartesian vector from polar coordinates */

sphrv(w,r,th,ph) double *w, r, th, ph; {double s;
s=r*sin(th);
w[0]=s*cos(ph);
w[1]=s*sin(ph);
w[2]=r*cos(th);
}

/* sphmv - vector = matrix * vector */

sphmv(w,o,z) double *w, o[3][3], *z; {
double u0, u1, u2;
u0=z[0]; u1=z[1]; u2=z[2];
w[0]=o[0][0]*u0+o[0][1]*u1+o[0][2]*u2;
w[1]=o[1][0]*u0+o[1][1]*u1+o[1][2]*u2;
w[2]=o[2][0]*u0+o[2][1]*u1+o[2][2]*u2;
}

/* sphvs - vector sum */

sphvs(z,x,y) double z[3], x[3], y[3]; {
z[0]=x[0]+y[0]; z[1]=x[1]+y[1]; z[2]=x[2]+y[2];}

/* sphzv - zero a vector */

sphzv(z) double *z; {z[0]=z[1]=z[2]=0.0;}

/* molhr - generate a hexagonal ring */

molhr(s,r,rr,a,b,c) double s[][7], r, rr, a, b, c; {int i; double ph;
for (i=0, ph=0.0; i<6; i++,ph+=(60.0*3.14159)/180.0) {
  s[i][0]=r*cos(ph); s[i][1]=0.0; s[i][2]=r*sin(ph);
  s[i][3]=rr;
  s[i][4]=a; s[i][5]=b; s[i][6]=c;}
}

/* molbe - generate a benzene molecule */

molbe(s,ac,rc,ah,rh) double s[][7], ac, rc, ah, rh; {
molhr(&s[0][0],rc,ac,30.0,50.0,40.0);
molhr(&s[6][0],rh,ah,-60.0,40.0,30.0);
}

/* molpr - generate a pentagonal ring */

molpr(s,r,rr,h,a,b,c) double s[][7], r, rr, h, a, b, c; {int i; double ph;
for (i=0, ph=0.0; i<5; i++,ph+=(72.0*3.14159)/180.0) {
  s[i][0]=r*cos(ph); s[i][1]=h; s[i][2]=r*sin(ph);
  s[i][3]=rr;
  s[i][4]=a; s[i][5]=b; s[i][6]=c;}
}

/* molps - generate a staggered pentagonal ring */

molps(s,r,rr,h,a,b,c) double s[][7], r, rr, h, a, b, c; {int i; double ph;
for (i=0, ph=(36.0*3.14159)/180.0; i<5; i++,ph+=(72.0*3.14159)/180.0) {
  s[i][0]=r*cos(ph); s[i][1]=h; s[i][2]=r*sin(ph);
  s[i][3]=rr;
  s[i][4]=a; s[i][5]=b; s[i][6]=c;}
}

/* molfc - generate a ferrocene molecule */

molfc(s,r1,r2,r3) double s[][7], r1, r2, r3; {
molpr(&s[0][0],1.4,r3,1.3,30.0,30.0,30.0);
molpr(&s[5][0],1.0,r2,1.0,30.0,30.0,30.0);
s[10][0]=s[10][1]=s[10][2]=0.0; s[10][3]=r1;
s[10][4]=80.0; s[10][5]=-30.0; s[10][6]=100.0;
molps(&s[11][0],1.0,r2,-1.0,30.0,30.0,30.0);
molps(&s[16][0],1.4,r3,-1.3,30.0,30.0,30.0);
}

molsc(x,y,z,p) double *x, *y, *z; int p; {
double d, al, be, t;
d=2.048;
al=3.1415926/4.0;
be=(107.9*3.1415926)/360.0;
t=sin(be)/cos(al/2.0);
*x=d*sin(be)*cos(p*al)/sin(al);
*y=d*sin(be)*sin(p*al)/sin(al);
*z=(p%2==0?1.0:-1.0)*(d/2.0)*sqrt(1.0-t);
}

/* molsu - generate coordinates of a sulfur ring */

molsu(s,radsu) double s[][7], radsu; {int i;
for (i=0; i<8; i++) {
molsc(&s[i][0],&s[i][1],&s[i][2],i);
s[i][3]=radsu;
s[i][4]=30.0;
s[i][5]=20.0;
s[i][6]=15.0;
}}

/* position the cursor according to option i */

twocur(i) int i; {
switch (i) {
case 1:  videocursor(0,4,2);   break;	/* g1 */
default: break;}
}

/* print the current option */

twopc(k) char k; {
videocursor(0,2,2); printf("%c",k);
videocursor(0,2,2);
    videoline(0,0,0,639,2);    videoline(0,639,199,639,2);
    videoline(199,639,199,0,2);    videoline(199,0,0,0,2);
    videoline(2,2,2,637,2);  videoline(2,637,197,637,2);
    videoline(197,637,197,2,2);   videoline(197,2,0,0,2);
}

/* twopm - print the components of a matrix */

twopm(z) double (*z)[3]; {int i, j;
printf("\n");
for (i=0; i<3; i++)  {
  for (j=0; j<3; j++)  printf("%4.2f  ",z[i][j]);
  printf("\n");
  }
}

/* twopv - print the components of a vector */

twopv(z) double *z; {int i;
for (i=0; i<3; i++)  printf("%4.2f  ",z[i]);
printf("\n");
}

/* place a dot within range (-2.0, 2.0)	*/
/* at coordinate (x,y), color l		*/

videoadot(x,y,l) double x, y; int l; {
videodot(199-(int)(42.5*y+100.0),(int)(50.0*x+160.0),l);}

/* place a dot within range (-2.0, 2.0)	*/
/* at coordinate (x,y), visibility l	*/

pltms(x,y,l) double x, y; int l; {int xx, yy;
xx=(int)(50.0*x+160.0); if (xx<0) xx=0; if (xx>320) xx=320;
yy=199-(int)(42.5*y+100.0); if (yy<0) yy=0; if (yy>200) yy=200;
if (l) videodot(yy,xx,1);
}

/* place a dot within range (-2.0, 2.0)	at */
/* coordinate (x,y), visibility l, color m */

geoms(x,y,l,m) double x, y; int l, m; {int xx, yy;
if (!l) return;
xx=(int)(50.0*x+160.0); if (xx<0) xx=0; if (xx>320) xx=320;
yy=199-(int)(42.5*y+100.0); if (yy<0) yy=0; if (yy>200) yy=200;
videodot(yy,xx,m);
}

/* end */
