
/* pen.h				*/
/* Harold V. McIntosh, 01 November 1972 */
/* 20 October 1993 - "C" version	*/

# define PTM  4				/* dimension of transfer matrix	 */
# define PDB  5				/* width of the diagonal band	 */
# define PDM 11				/* dimension of dynamical matrix */
# define penij(z,x,i,j) pencm(z[i][j],x)

void penau(double z[4][4], double x[4][4], double f, double y[4][4]);
void pencd(double dm[][11][4][4], double db[][PDB][4][4], int l, int n);
void pencm(double z[4][4], double x[4][4]);
void pencv(double z[4], double x[4]); 
void pendb(double db[PDM][PDB], double f, double s);
double  pende(double z[4][4]);
void pendy(double z[4][4], double x[4], double y[4]);
void penfs(double db[][PDB][4][4], double sk[][4], double c, int i);
void penmi(double z[4][4], double x[4][4]);
void penmp(double z[4][4], double x[4][4], double y[4][4]);
void penmt(double z[4][4], double x[4][4]);
void penne(double z[4][4], double x[4][4]);
void penno(double z[4]);
void pensk(double sk[][4], double r, double h, double a, int n);
void penss(double db[][PDB][4][4], double sk[][4], double c, int i);
void penst(double x[4], double sk[][4], int i, int j);
void pentm(double z[PTM][PTM], double db[][PDB][4][4], double e, int l);
void pents(double db[][PDB][4][4], double sk[][4], double c, int i);
void penud(double dm[21][21][4][4], double db[][PDB][4][4], int l, int n);
void penutm(double z[PTM][PTM]);
void penvp(double z[4], double x[4],double  y[4]); 
void penwb(double z[][PDB][4][4], int n);
void penwm(double z[4][4], char *c);

void penztm(double z[PTM][PTM]);
void penzdm(double z[PDM][PDM]);

/* end penf.h */
